Imports System.IO
Imports Stax
Imports Stax.UI
Imports System.Text.RegularExpressions
Imports System.Xml
Imports System.Text

Namespace AppFramework
    Public Class HelpForm
        Inherits Form

#Region " Designer "
        <System.Diagnostics.DebuggerNonUserCode()> _
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing AndAlso components IsNot Nothing Then
                components.Dispose()
            End If
            MyBase.Dispose(disposing)
        End Sub

        Private components As System.ComponentModel.IContainer

        Friend WithEvents Browser As System.Windows.Forms.WebBrowser
        <System.Diagnostics.DebuggerStepThrough()> _
        Private Sub InitializeComponent()
            Me.Browser = New System.Windows.Forms.WebBrowser
            Me.SuspendLayout()
            '
            'Browser
            '
            Me.Browser.Dock = System.Windows.Forms.DockStyle.Fill
            Me.Browser.Location = New System.Drawing.Point(0, 0)
            Me.Browser.Name = "Browser"
            Me.Browser.Size = New System.Drawing.Size(694, 499)
            Me.Browser.TabIndex = 0
            '
            'HelpForm
            '
            Me.AutoScaleDimensions = New System.Drawing.SizeF(6.0!, 13.0!)
            Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font
            Me.ClientSize = New System.Drawing.Size(694, 499)
            Me.Controls.Add(Me.Browser)
            Me.KeyPreview = True
            Me.Name = "HelpForm"
            Me.ResumeLayout(False)

        End Sub
#End Region

        Public Sub New()
            InitializeComponent()
            Icon = StaxApplication.Icon
            StaxApplication.WindowPositions.RestorePosition(Me)
        End Sub

        Public Sub New(ByVal path As String)
            Me.New()

            Try
                Browser.Navigate(path)
            Catch ex As Exception
                Msg.Show("Failed to load: " + path, MsgIcon.Warning)
            End Try
        End Sub

        Private DocumentValue As HelpDocument

        Public Property Doc() As HelpDocument
            Get
                If DocumentValue Is Nothing Then
                    DocumentValue = New HelpDocument(CommonDirs.Temp + "StaxRipAuto.htm")
                End If

                Return DocumentValue
            End Get
            Set(ByVal Value As HelpDocument)
                DocumentValue = Value
            End Set
        End Property

        Public Overloads Shared Sub ShowDialog(ByVal heading As String, ByVal tips As StringPairList)
            ShowDialog(heading, tips, Nothing)
        End Sub

        Public Overloads Shared Sub ShowDialog(ByVal heading As String, ByVal tips As StringPairList, ByVal summary As String)
            Dim f As New HelpForm()
            f.Doc.WriteStart(heading)

            If Not summary Is Nothing Then
                f.Doc.WriteP(summary)
            End If

            f.Doc.WriteTips(tips)
            f.Show()
        End Sub

        Private Sub HelpForm_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles MyBase.FormClosed
            StaxApplication.WindowPositions.Save(Me)
            Dispose()
        End Sub

        Private Sub Browser_DocumentCompleted(ByVal sender As Object, ByVal e As WebBrowserDocumentCompletedEventArgs) Handles Browser.DocumentCompleted
            WebBrowserHelp.ResetTextSize(Browser)
        End Sub

        Private Sub Browser_Navigated(ByVal sender As Object, ByVal e As WebBrowserNavigatedEventArgs) Handles Browser.Navigated
            If OK(Browser.DocumentTitle) Then
                Text = Browser.DocumentTitle
            ElseIf File.Exists(e.Url.LocalPath) Then
                Text = e.Url.LocalPath.Path.Base
            End If
        End Sub

        Public Shadows Sub Show()
            MyBase.Show()
            Application.DoEvents()

            If Not DocumentValue Is Nothing Then
                DocumentValue.WriteDocument(Browser)
            End If
        End Sub

        Private Sub Browser_Navigating(ByVal sender As Object, ByVal e As WebBrowserNavigatingEventArgs) Handles Browser.Navigating
            If e.Url.AbsoluteUri.StartsWith("http://") Then
                e.Cancel = True
                Proc.StartFile(e.Url.ToString)
            End If
        End Sub
    End Class
End Namespace