Imports Stax.UI

Namespace AppFramework
    Public Class SettingTreeViewForm
        Inherits DialogBase

#Region " Designer "

        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

        Public WithEvents SettingTreeView As Stax.UI.SettingTreeView

        Private components As System.ComponentModel.IContainer

        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.SettingTreeView = New Stax.UI.SettingTreeView
            Me.SuspendLayout()
            '
            'SettingTreeView
            '
            Me.SettingTreeView.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.SettingTreeView.AutoCollaps = True
            Me.SettingTreeView.ExpandMode = TreeNodeExpandMode.InclusiveChilds
            Me.SettingTreeView.HideSelection = False
            Me.SettingTreeView.Location = New System.Drawing.Point(13, 13)
            Me.SettingTreeView.Name = "SettingTreeView"
            Me.SettingTreeView.SelectOnMouseDown = True
            Me.SettingTreeView.Size = New System.Drawing.Size(480, 241)
            Me.SettingTreeView.TabIndex = 2
            '
            'SettingTreeViewForm
            '
            Me.ClientSize = New System.Drawing.Size(505, 299)
            Me.Controls.Add(Me.SettingTreeView)
            Me.Name = "SettingTreeViewForm"
            Me.Text = "SettingTreeViewForm"
            Me.Controls.SetChildIndex(Me.SettingTreeView, 0)
            Me.ResumeLayout(False)

        End Sub

#End Region

        Private HelpParagraphs As String()

        Public Sub New(ByVal title As String, ByVal ParamArray helpParagraphs As String())
            MyBase.New()
            InitializeComponent()
            Text = title
            Me.HelpParagraphs = helpParagraphs
            SetTypeTitleHelpId()
        End Sub

        Private DocumentValue As HelpDocument

        Public Property Document() As HelpDocument
            Get
                If DocumentValue Is Nothing Then
                    DocumentValue = New HelpDocument(CommonDirs.Temp + "StaxRipAuto.htm")
                    DocumentValue.WriteStart(Text)

                    If Not HelpParagraphs Is Nothing Then
                        For Each i As String In HelpParagraphs
                            DocumentValue.WriteElement("p", i)
                        Next
                    End If

                    DocumentValue.WriteTips(SettingTreeView.GetTips)
                End If

                Return DocumentValue
            End Get
            Set(ByVal Value As HelpDocument)
                DocumentValue = Value
            End Set
        End Property

        Private Sub SettingTreeViewForm_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed
            If DialogResult = Windows.Forms.DialogResult.OK Then
                SettingTreeView.Apply()
            End If
        End Sub

        Private Sub SettingTreeViewForm_HelpRequested(ByVal sender As Object, ByVal e As HelpEventArgs) Handles Me.HelpRequested
            Dim f As New HelpForm()
            f.Doc = Document
            f.Show()
        End Sub

        Private Sub SettingTreeViewForm_Shown() Handles Me.Shown
            Document.WriteDocument()
        End Sub
    End Class
End Namespace