Imports Stax.UI
Imports System.IO

Namespace AppFramework
    Public Class Appearance
        Public Shared GradientColorLight As Color = ControlPaint.LightLight(SystemColors.GradientActiveCaption)
        Public Shared GradientColor As Color = ControlPaint.Light(SystemColors.GradientActiveCaption)
    End Class

    Public Class StaxApplication
        Public Shared StringList As List(Of String)
        Public Shared StringDictionary As Dictionary(Of String, String)
        Public Shared Icon As Icon
        Public Shared WindowPositions As WindowPositions
        Public Shared ShowInitialHelp As Boolean = True
        Public Shared ShowToolTips As Boolean = True
        Public Shared WindowPositionsRemembered As String()
        Public Shared WindowPositionsCenterScreen As String()

        Public Shared Event HelpRequested(ByVal e As ExtendedHelpEventArgs)
        Public Shared Event ErrorMessage(ByVal message As String)

        Public Shared Sub RaiseHelpRequested(ByVal e As ExtendedHelpEventArgs)
            RaiseEvent HelpRequested(e)
        End Sub

        Public Shared Sub RaiseErrorMessage(ByVal message As String)
            RaiseEvent ErrorMessage(message)
        End Sub

        Private Shared MainImagePathValue As String

        Public Shared Property MainImagePath() As String
            Get
                If Not File.Exists(MainImagePathValue) Then
                    File.WriteAllBytes(MainImagePathValue, My.Resources.main_gif)
                End If

                Return MainImagePathValue
            End Get
            Set(ByVal value As String)
                MainImagePathValue = value
            End Set
        End Property

        Private Shared BackgroundImagePathValue As String

        Public Shared Property BackgroundImagePath() As String
            Get
                If Not File.Exists(BackgroundImagePathValue) Then
                    File.WriteAllBytes(BackgroundImagePathValue, My.Resources.background_gif)
                End If

                Return BackgroundImagePathValue
            End Get
            Set(ByVal value As String)
                BackgroundImagePathValue = value
            End Set
        End Property
    End Class
End Namespace