Imports Stax.UI
Imports System.ComponentModel

Namespace UI
    Public Class ListViewControl
        Inherits UserControl

#Region " Designer "
        <DebuggerNonUserCode()> _
        Protected Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing AndAlso components IsNot Nothing Then
                components.Dispose()
            End If

            MyBase.Dispose(disposing)
        End Sub
        Friend WithEvents bRemove As System.Windows.Forms.Button
        Friend WithEvents bAdd As System.Windows.Forms.Button
        Friend WithEvents bDown As System.Windows.Forms.Button
        Friend WithEvents bUp As System.Windows.Forms.Button
        Friend WithEvents bEdit As System.Windows.Forms.Button
        Public WithEvents lv As Stax.UI.ExtendedListView

        Private components As System.ComponentModel.IContainer

        <DebuggerStepThrough()> _
        Private Sub InitializeComponent()
            Me.bRemove = New System.Windows.Forms.Button
            Me.bAdd = New System.Windows.Forms.Button
            Me.bDown = New System.Windows.Forms.Button
            Me.bUp = New System.Windows.Forms.Button
            Me.bEdit = New System.Windows.Forms.Button
            Me.lv = New Stax.UI.ExtendedListView
            Me.SuspendLayout()
            '
            'bRemove
            '
            Me.bRemove.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.bRemove.Image = Global.Stax.My.Resources.Resources.Minus16
            Me.bRemove.Location = New System.Drawing.Point(229, 33)
            Me.bRemove.Name = "bRemove"
            Me.bRemove.Size = New System.Drawing.Size(75, 24)
            Me.bRemove.TabIndex = 2
            Me.bRemove.Text = "Remove"
            Me.bRemove.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText
            Me.bRemove.UseVisualStyleBackColor = True
            '
            'bAdd
            '
            Me.bAdd.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.bAdd.Image = Global.Stax.My.Resources.Resources.Plus16
            Me.bAdd.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
            Me.bAdd.Location = New System.Drawing.Point(229, 3)
            Me.bAdd.Name = "bAdd"
            Me.bAdd.Size = New System.Drawing.Size(75, 24)
            Me.bAdd.TabIndex = 1
            Me.bAdd.Text = "Add"
            Me.bAdd.UseVisualStyleBackColor = True
            '
            'bDown
            '
            Me.bDown.Anchor = System.Windows.Forms.AnchorStyles.Right
            Me.bDown.Image = Global.Stax.My.Resources.Resources.Down16
            Me.bDown.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
            Me.bDown.Location = New System.Drawing.Point(229, 119)
            Me.bDown.Name = "bDown"
            Me.bDown.Size = New System.Drawing.Size(75, 24)
            Me.bDown.TabIndex = 4
            Me.bDown.Text = "Down"
            Me.bDown.UseVisualStyleBackColor = True
            '
            'bUp
            '
            Me.bUp.Anchor = System.Windows.Forms.AnchorStyles.Right
            Me.bUp.Image = Global.Stax.My.Resources.Resources.Up16
            Me.bUp.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
            Me.bUp.Location = New System.Drawing.Point(229, 89)
            Me.bUp.Name = "bUp"
            Me.bUp.Size = New System.Drawing.Size(75, 24)
            Me.bUp.TabIndex = 3
            Me.bUp.Text = "Up"
            Me.bUp.UseVisualStyleBackColor = True
            '
            'bEdit
            '
            Me.bEdit.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.bEdit.Image = Global.Stax.My.Resources.Resources.Config16
            Me.bEdit.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
            Me.bEdit.Location = New System.Drawing.Point(229, 204)
            Me.bEdit.Name = "bEdit"
            Me.bEdit.Size = New System.Drawing.Size(75, 24)
            Me.bEdit.TabIndex = 5
            Me.bEdit.Text = "Edit"
            Me.bEdit.UseVisualStyleBackColor = True
            '
            'lv
            '
            Me.lv.AllowDrop = True
            Me.lv.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.lv.Editable = True
            Me.lv.FullRowSelect = True
            Me.lv.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
            Me.lv.HideSelection = False
            Me.lv.Location = New System.Drawing.Point(3, 3)
            Me.lv.MultiSelect = False
            Me.lv.Name = "lv"
            Me.lv.Size = New System.Drawing.Size(220, 225)
            Me.lv.TabIndex = 7
            Me.lv.UseCompatibleStateImageBehavior = False
            Me.lv.View = System.Windows.Forms.View.Details
            '
            'ListViewControl
            '
            Me.AutoScaleDimensions = New System.Drawing.SizeF(6.0!, 13.0!)
            Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font
            Me.Controls.Add(Me.lv)
            Me.Controls.Add(Me.bEdit)
            Me.Controls.Add(Me.bDown)
            Me.Controls.Add(Me.bUp)
            Me.Controls.Add(Me.bRemove)
            Me.Controls.Add(Me.bAdd)
            Me.Name = "ListViewControl"
            Me.Size = New System.Drawing.Size(307, 231)
            Me.ResumeLayout(False)

        End Sub

#End Region

        Public Event ButtonClickAdd()
        Public Event ButtonClickEdit()

        Public Sub New()
            MyBase.New()
            InitializeComponent()
        End Sub

        Private ShowEditButtonValue As Boolean = True

        <DefaultValue(True)> _
        Public Property ShowEditButton() As Boolean
            Get
                Return ShowEditButtonValue
            End Get
            Set(ByVal Value As Boolean)
                ShowEditButtonValue = Value
                bEdit.Visible = Value
            End Set
        End Property

        Private ShowUpDownValue As Boolean = True

        <DefaultValue(True)> _
        Public Property ShowUpDown() As Boolean
            Get
                Return ShowUpDownValue
            End Get
            Set(ByVal Value As Boolean)
                ShowUpDownValue = Value
                bUp.Visible = Value
                bDown.Visible = Value

                If Value Then
                    lv.Sorting = SortOrder.None
                Else
                    lv.Sorting = SortOrder.Ascending
                End If
            End Set
        End Property

        Public Sub UpdateControls()
            bRemove.Enabled = lv.SelectedItems.Count > 0
            bUp.Enabled = lv.CanMoveUp()
            bDown.Enabled = lv.CanMoveDown()
            bEdit.Enabled = lv.SelectedItems.Count = 1
        End Sub

        Protected Overrides Sub OnLoad(ByVal e As EventArgs)
            If lv.Items.Count > 0 Then
                lv.Items(0).Selected = True
            End If

            UpdateControls()
            MyBase.OnLoad(e)
        End Sub

        Private Sub bAdd_Click() Handles bAdd.Click
            RaiseEvent ButtonClickAdd()
            UpdateControls()
        End Sub

        Private Sub bRemove_Click() Handles bRemove.Click
            lv.RemoveSelection()
            UpdateControls()
        End Sub

        Private Sub bUp_Click() Handles bUp.Click
            lv.MoveSelectionUp()
            UpdateControls()
        End Sub

        Private Sub bDown_Click() Handles bDown.Click
            lv.MoveSelectionDown()
            UpdateControls()
        End Sub

        Private Sub bEdit_Click() Handles bEdit.Click
            RaiseEvent ButtonClickEdit()
            UpdateControls()
        End Sub

        Private Sub lv_SelectedIndexChanged() Handles lv.SelectedIndexChanged
            UpdateControls()
        End Sub

        Private Sub lv_DoubleClick() Handles lv.DoubleClick
            If lv.SelectedItems.Count > 0 Then
                bEdit.PerformClick()
            Else
                bAdd.PerformClick()
            End If
        End Sub

        'designer fires only when control is hosted
        Protected Overrides Sub OnLayout(ByVal e As LayoutEventArgs)
            MyBase.OnLayout(e)

            bUp.Top = Height \ 2 - bAdd.Margin.Top - bUp.Height

            If bUp.Top < 63 Then
                bUp.Top = 63
            End If

            bDown.Top = bUp.Top + bUp.Height + bAdd.Margin.Top * 2
        End Sub
    End Class
End Namespace