Imports System.ComponentModel

Namespace UI
    Public Class CriteriaControl
        Inherits ExtendedPanel

#Region " Designer "
        Friend WithEvents bAdd As System.Windows.Forms.Button

        <System.Diagnostics.DebuggerStepThrough()> _
        Private Sub InitializeComponent()
            Me.bAdd = New System.Windows.Forms.Button
            Me.SuspendLayout()
            '
            'bAdd
            '
            Me.bAdd.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.bAdd.Location = New System.Drawing.Point(498, 7)
            Me.bAdd.Margin = New System.Windows.Forms.Padding(7)
            Me.bAdd.Name = "bAdd"
            Me.bAdd.Size = New System.Drawing.Size(24, 24)
            Me.bAdd.TabIndex = 0
            Me.bAdd.Text = "+"
            Me.bAdd.UseVisualStyleBackColor = True
            '
            'CriteriaControl
            '
            Me.BackColor = System.Drawing.SystemColors.Window
            Me.Controls.Add(Me.bAdd)
            Me.ShowNiceBorder = True
            Me.Name = "CriteriaControl"
            Me.Size = New System.Drawing.Size(528, 250)
            Me.ResumeLayout(False)
        End Sub
#End Region

        Private ControlList As New List(Of CriteriaItemControl)

        Public Sub New()
            InitializeComponent()
        End Sub

        Private Sub AddItem(ByVal criteria As Criteria)
            Dim c As New CriteriaItemControl(AllCrieria)
            ControlList.Add(c)
            c.Criteria = criteria
            c.Anchor = AnchorStyles.Left Or AnchorStyles.Top Or AnchorStyles.Right
            c.Left = Padding.Left + c.Margin.Left
            c.Width = ClientSize.Width - Padding.Left - Padding.Right - c.Margin.Left - c.Margin.Right
            c.Top = GetTop(c)
            SetAddButtonTop()
            Controls.Add(c)
        End Sub

        Private Sub bAdd_Click() Handles bAdd.Click
            AddItem(Nothing)
        End Sub

        Private Sub SetAddButtonTop()
            If ControlList.Count = 0 Then
                bAdd.Top = 7
            Else
                Dim c As Control = ControlList(ControlList.Count - 1)
                bAdd.Visible = Not (c.Top + c.Height + 2) + bAdd.Height > Height
                bAdd.Top = c.Top + c.Height + 2
            End If
        End Sub

        Private Function GetTop(ByVal c As CriteriaItemControl) As Integer
            Dim ret As Integer = c.Margin.Top + Padding.Top + 2

            If ControlList.IndexOf(c) > 0 Then
                Dim above As Control = ControlList(ControlList.IndexOf(c) - 1)
                ret = above.Top + c.Height
            End If

            Return ret
        End Function

        Private Sub ItemsPanel_ControlRemoved(ByVal sender As Object, ByVal e As ControlEventArgs) Handles Me.ControlRemoved
            Dim c As CriteriaItemControl = DirectCast(e.Control, CriteriaItemControl)

            If ControlList.Contains(c) Then
                ControlList.Remove(c)
            End If

            For Each i As CriteriaItemControl In ControlList
                i.Top = GetTop(i)
            Next

            SetAddButtonTop()
        End Sub

        <Browsable(False), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
        Public Property CriteriaList() As List(Of Criteria)
            Get
                Dim ret As New List(Of Criteria)

                For Each i As CriteriaItemControl In ControlList
                    If Not i.Criteria Is Nothing Then
                        ret.Add(i.Criteria)
                    End If
                Next

                Return ret
            End Get
            Set(ByVal Value As List(Of Criteria))
                While ControlList.Count > 0
                    ControlList(ControlList.Count - 1).bRemove.PerformClick()
                End While

                If Not Value Is Nothing Then
                    For Each i As Criteria In Value
                        AddItem(i)
                    Next
                End If
            End Set
        End Property

        Private AllCrieriaValue As List(Of Criteria)

        <Browsable(False), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
        Public Property AllCrieria() As List(Of Criteria)
            Get
                Return AllCrieriaValue
            End Get
            Set(ByVal Value As List(Of Criteria))
                AllCrieriaValue = Value
            End Set
        End Property
    End Class
End Namespace