Imports Stax
Imports Stax.UI
Imports System.ComponentModel

Namespace UI
    <ToolboxItem(False)> _
    Public Class CriteriaItemControl
        Private IsLoading As Boolean

        Public Sub New(ByVal allCriteria As List(Of Criteria))
            InitializeComponent()
            cbProperty.Items.AddRange(allCriteria.ToArray)
        End Sub

        Private CriteriaValue As Criteria

        Public Property Criteria() As Criteria
            Get
                Return CriteriaValue
            End Get
            Set(ByVal Value As Criteria)
                If Not Value Is Nothing Then
                    CriteriaValue = DirectCast(ObjectHelp.GetCopy(Value), Criteria)
                    IsLoading = True

                    For i As Integer = 0 To cbProperty.Items.Count - 1
                        Dim c As Criteria = DirectCast(cbProperty.Items(i), Criteria)

                        If c.Name = CriteriaValue.Name Then
                            cbProperty.SelectedIndex = i
                            Exit For
                        End If
                    Next

                    cbCondition.Items.Clear()
                    cbCondition.Items.AddRange(CriteriaValue.ConditionNames)
                    cbCondition.SelectedItem = CriteriaValue.ConditionName
                    tbValue.Text = CriteriaValue.ValueString

                    IsLoading = False
                End If
            End Set
        End Property

        Private Sub bRemove_Click() Handles bRemove.Click
            Parent.Controls.Remove(Me)
        End Sub

        Private Sub cbProperty_SelectedIndexChanged() Handles cbProperty.SelectedIndexChanged
            If Not IsLoading AndAlso Not cbProperty.SelectedItem Is Nothing Then
                Criteria = DirectCast(cbProperty.SelectedItem, Criteria)
            End If
        End Sub

        Private Sub cbCondition_SelectedIndexChanged() Handles cbCondition.SelectedIndexChanged
            If Not IsLoading AndAlso Not cbCondition.SelectedItem Is Nothing Then
                Criteria.ConditionName = cbCondition.SelectedItem.ToString
            End If
        End Sub

        Private Sub tbValue_TextChanged() Handles tbValue.TextChanged
            If Not IsLoading Then
                Criteria.ValueString = tbValue.Text
            End If
        End Sub
    End Class
End Namespace
