﻿Imports System.ComponentModel
Imports System.ComponentModel.Design
Imports System.Windows.Forms.Design

Namespace UI.Design
    Public Class ActionListInitLabel
        Inherits ExtendedLabel

        Private WasInitialized As Boolean

        Public Property Dummy() As Boolean
            Get
                If Not WasInitialized Then
                    WasInitialized = True
                    Init(Me)
                End If
            End Get
            Set(ByVal Value As Boolean)
                If Not WasInitialized Then
                    WasInitialized = True
                    Init(Me)
                End If
            End Set
        End Property

        Shared Sub Init(ByVal c As IComponent)
            If Not c.Site Is Nothing Then
                Dim s = DirectCast(c.Site.GetService(GetType(IComponentChangeService)), IComponentChangeService)
                AddHandler s.ComponentAdded, AddressOf OnComponentAdded
                AddLists(c)
            End If
        End Sub

        Shared Sub AddLists(ByVal c As IComponent)
            Dim host = DirectCast(c.Site.GetService(GetType(IDesignerHost)), IDesignerHost)

            For Each i As Component In host.Container.Components
                If TypeOf i Is Control Then
                    If TypeOf host.GetDesigner(i) Is ControlDesigner Then
                        Dim cd = DirectCast(host.GetDesigner(i), ControlDesigner)

                        If Not ContainsList(cd, GetType(CommonActionList)) Then
                            If TypeOf i Is TextBox Then
                                cd.ActionLists.Clear()
                            End If

                            If Not TypeOf i Is PageControl Then
                                cd.ActionLists.Add(New CommonActionList(i, cd.ActionLists))
                            End If
                        End If
                    End If
                End If
            Next
        End Sub

        Shared Function ContainsList(ByVal d As ControlDesigner, ByVal t As Type) As Boolean
            For Each i In d.ActionLists
                If i.GetType Is t Then
                    Return True
                End If
            Next
        End Function

        Shared Sub OnComponentAdded(ByVal sender As Object, ByVal e As ComponentEventArgs)
            AddLists(e.Component)
        End Sub
    End Class
End Namespace