Imports System.Windows.Forms.Design

Namespace UI.Design
    Public Class AnchorStylesEditorControl
        Inherits UserControl

#Region " Designer "
        <DebuggerNonUserCode()> _
        Protected Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing AndAlso components IsNot Nothing Then
                components.Dispose()
            End If

            MyBase.Dispose(disposing)
        End Sub
        Friend WithEvents TableLayoutPanel1 As System.Windows.Forms.TableLayoutPanel
        Friend WithEvents bTop As System.Windows.Forms.Button
        Friend WithEvents bLeft As System.Windows.Forms.Button
        Friend WithEvents bOK As System.Windows.Forms.Button
        Friend WithEvents bRight As System.Windows.Forms.Button
        Friend WithEvents bBottom As System.Windows.Forms.Button

        Private components As System.ComponentModel.IContainer

        <DebuggerStepThrough()> _
        Private Sub InitializeComponent()
            Me.TableLayoutPanel1 = New System.Windows.Forms.TableLayoutPanel
            Me.bTop = New System.Windows.Forms.Button
            Me.bLeft = New System.Windows.Forms.Button
            Me.bOK = New System.Windows.Forms.Button
            Me.bRight = New System.Windows.Forms.Button
            Me.bBottom = New System.Windows.Forms.Button
            Me.TableLayoutPanel1.SuspendLayout()
            Me.SuspendLayout()
            '
            'TableLayoutPanel1
            '
            Me.TableLayoutPanel1.ColumnCount = 3
            Me.TableLayoutPanel1.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 33.33333!))
            Me.TableLayoutPanel1.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 33.33333!))
            Me.TableLayoutPanel1.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 33.33333!))
            Me.TableLayoutPanel1.Controls.Add(Me.bTop, 1, 0)
            Me.TableLayoutPanel1.Controls.Add(Me.bLeft, 0, 1)
            Me.TableLayoutPanel1.Controls.Add(Me.bOK, 1, 1)
            Me.TableLayoutPanel1.Controls.Add(Me.bRight, 2, 1)
            Me.TableLayoutPanel1.Controls.Add(Me.bBottom, 1, 2)
            Me.TableLayoutPanel1.Dock = System.Windows.Forms.DockStyle.Fill
            Me.TableLayoutPanel1.Location = New System.Drawing.Point(0, 0)
            Me.TableLayoutPanel1.Name = "TableLayoutPanel1"
            Me.TableLayoutPanel1.RowCount = 3
            Me.TableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 33.33333!))
            Me.TableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 33.33333!))
            Me.TableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 33.33333!))
            Me.TableLayoutPanel1.Size = New System.Drawing.Size(150, 150)
            Me.TableLayoutPanel1.TabIndex = 0
            '
            'Button2
            '
            Me.bTop.Dock = System.Windows.Forms.DockStyle.Fill
            Me.bTop.Location = New System.Drawing.Point(50, 0)
            Me.bTop.Margin = New System.Windows.Forms.Padding(0)
            Me.bTop.Name = "Button2"
            Me.bTop.Size = New System.Drawing.Size(50, 50)
            Me.bTop.TabIndex = 1
            Me.bTop.UseVisualStyleBackColor = True
            '
            'Button4
            '
            Me.bLeft.Dock = System.Windows.Forms.DockStyle.Fill
            Me.bLeft.Location = New System.Drawing.Point(0, 50)
            Me.bLeft.Margin = New System.Windows.Forms.Padding(0)
            Me.bLeft.Name = "Button4"
            Me.bLeft.Size = New System.Drawing.Size(50, 50)
            Me.bLeft.TabIndex = 3
            Me.bLeft.UseVisualStyleBackColor = True
            '
            'bOK
            '
            Me.bOK.Dock = System.Windows.Forms.DockStyle.Fill
            Me.bOK.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
            Me.bOK.Location = New System.Drawing.Point(50, 50)
            Me.bOK.Margin = New System.Windows.Forms.Padding(0)
            Me.bOK.Name = "bOK"
            Me.bOK.Size = New System.Drawing.Size(50, 50)
            Me.bOK.TabIndex = 4
            Me.bOK.Text = "OK"
            Me.bOK.UseVisualStyleBackColor = True
            '
            'Button6
            '
            Me.bRight.Dock = System.Windows.Forms.DockStyle.Fill
            Me.bRight.Location = New System.Drawing.Point(100, 50)
            Me.bRight.Margin = New System.Windows.Forms.Padding(0)
            Me.bRight.Name = "Button6"
            Me.bRight.Size = New System.Drawing.Size(50, 50)
            Me.bRight.TabIndex = 5
            Me.bRight.UseVisualStyleBackColor = True
            '
            'Button8
            '
            Me.bBottom.Dock = System.Windows.Forms.DockStyle.Fill
            Me.bBottom.Location = New System.Drawing.Point(50, 100)
            Me.bBottom.Margin = New System.Windows.Forms.Padding(0)
            Me.bBottom.Name = "Button8"
            Me.bBottom.Size = New System.Drawing.Size(50, 50)
            Me.bBottom.TabIndex = 7
            Me.bBottom.UseVisualStyleBackColor = True
            '
            'AnchorStylesEditorControl
            '
            Me.AutoScaleDimensions = New System.Drawing.SizeF(6.0!, 13.0!)
            Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font
            Me.Controls.Add(Me.TableLayoutPanel1)
            Me.Name = "AnchorStylesEditorControl"
            Me.TableLayoutPanel1.ResumeLayout(False)
            Me.ResumeLayout(False)

        End Sub

#End Region

        Public Style As AnchorStyles

        Private Styles As New Dictionary(Of Button, AnchorStyles)
        Private EditorService As IWindowsFormsEditorService

        Public Sub New(ByVal editorService As IWindowsFormsEditorService, ByVal value As AnchorStyles)
            MyBase.New()
            InitializeComponent()

            Me.EditorService = editorService
            Style = value

            Styles.Add(bTop, AnchorStyles.Top)
            Styles.Add(bLeft, AnchorStyles.Left)
            Styles.Add(bRight, AnchorStyles.Right)
            Styles.Add(bBottom, AnchorStyles.Bottom)

            For Each i As Button In Styles.Keys
                AddHandler i.Click, AddressOf ButtonClick
            Next

            SetImages()
        End Sub

        Private Sub SetImages()
            For Each i As Button In Styles.Keys
                If (Styles(i) And Style) = Styles(i) Then
                    i.Image = My.Resources.LedLightBlue
                Else
                    i.Image = Nothing
                End If
            Next
        End Sub

        Public Sub ButtonClick(ByVal sender As Object, ByVal e As EventArgs)
            Dim b = DirectCast(sender, Button)

            If b.Image Is Nothing Then
                Style = Style Or Styles(b)
            Else
                Style = Style Xor Styles(b)
            End If

            SetImages()
        End Sub

        Private Sub bOK_Click() Handles bOK.Click
            EditorService.CloseDropDown()
        End Sub
    End Class
End Namespace