Imports System.ComponentModel
Imports System.ComponentModel.Design
Imports System.Windows.Forms
Imports System.Windows.Forms.Design

Namespace UI.Design
    Public Class LineControlDesigner
        Inherits ControlDesigner

        Private LineControl As LineControl

        Public Overrides Sub Initialize(ByVal component As IComponent)
            MyBase.Initialize(component)
            LineControl = DirectCast(component, LineControl)
        End Sub

        Public Overrides Sub InitializeNewComponent(ByVal defaultValues As IDictionary)
            MyBase.InitializeNewComponent(defaultValues)
            LineControl.Text = ""
            LineControl.Height = 10
            LineControl.Width = 200
            LineControl.TabStop = False
        End Sub
    End Class

    Public Class CommandButtonDesigner
        Inherits ControlDesigner

        Private CommandButton As CommandButton

        Public Overrides Sub Initialize(ByVal component As IComponent)
            MyBase.Initialize(component)
            CommandButton = DirectCast(component, CommandButton)
        End Sub

        Public Overrides Sub InitializeNewComponent(ByVal defaultValues As IDictionary)
            MyBase.InitializeNewComponent(defaultValues)
            CommandButton.Text = ""
            CommandButton.Height = 55
            CommandButton.Width = CommandButton.Parent.ClientSize.Width - (CommandButton.Parent.Padding.Left * 2) - (CommandButton.Parent.Margin.Left * 2)
            CommandButton.TabStop = False
            CommandButton.Padding = New Padding(2)
        End Sub
    End Class

    Public Class DialogButtonsDesigner
        Inherits ControlDesigner

        Private DialogButtons As DialogButtons

        Public Overrides Sub Initialize(ByVal component As IComponent)
            MyBase.Initialize(component)
            DialogButtons = CType(component, DialogButtons)
        End Sub

        Public Overrides Sub InitializeNewComponent(ByVal defaultValues As IDictionary)
            MyBase.InitializeNewComponent(defaultValues)
            DialogButtons.Dock = DockStyle.Bottom
        End Sub

        Public Overrides ReadOnly Property SelectionRules() As SelectionRules
            Get
                Return SelectionRules.None
            End Get
        End Property
    End Class
End Namespace