Imports System.ComponentModel

Imports Stax.AppFramework

Namespace UI
    Public Class DialogBase
        Inherits Form

#Region " Designer "

        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub
        Private WithEvents DialogButtonsControl As Stax.DialogButtons


        Private components As System.ComponentModel.IContainer

        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.DialogButtonsControl = New Stax.DialogButtons
            Me.SuspendLayout()
            '
            'DialogButtonsControl
            '
            Me.DialogButtonsControl.BackColor = System.Drawing.Color.Transparent
            Me.DialogButtonsControl.Dock = System.Windows.Forms.DockStyle.Bottom
            Me.DialogButtonsControl.Location = New System.Drawing.Point(0, 314)
            Me.DialogButtonsControl.Margin = New System.Windows.Forms.Padding(0)
            Me.DialogButtonsControl.Name = "DialogButtonsControl"
            Me.DialogButtonsControl.Padding = New System.Windows.Forms.Padding(9)
            Me.DialogButtonsControl.Size = New System.Drawing.Size(465, 52)
            Me.DialogButtonsControl.TabIndex = 0
            '
            'DialogBase
            '
            Me.ClientSize = New System.Drawing.Size(465, 366)
            Me.Controls.Add(Me.DialogButtonsControl)
            Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
            Me.HelpButton = True
            Me.MaximizeBox = False
            Me.MinimizeBox = False
            Me.Name = "DialogBase"
            Me.ShowIcon = False
            Me.ShowInTaskbar = False
            Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
            Me.ResumeLayout(False)

        End Sub

#End Region

        Public Sub New()
            MyBase.New()
            InitializeComponent()

            If Not StaxApplication.WindowPositions Is Nothing Then
                StaxApplication.WindowPositions.RestorePosition(Me)
            End If

            AcceptButton = DialogButtonsControl.bOK
            CancelButton = DialogButtonsControl.bCancel
        End Sub

        Private OnlyCloseValue As Boolean

        <DefaultValue(False)> _
        Public Property OnlyClose() As Boolean
            Get
                Return OnlyCloseValue
            End Get
            Set(ByVal Value As Boolean)
                OnlyCloseValue = Value

                DialogButtonsControl.bOK.Visible = Not Value

                If OnlyCloseValue Then
                    DialogButtonsControl.bCancel.Text = "Close"
                Else
                    DialogButtonsControl.bCancel.Text = "OK"
                End If
            End Set
        End Property

        Protected Overrides Sub OnHelpButtonClicked(ByVal e As CancelEventArgs)
            e.Cancel = True
            MyBase.OnHelpButtonClicked(e)
            OnHelpRequested(New HelpEventArgs(MousePosition))
        End Sub

        Protected Overrides Sub OnFormClosed(ByVal e As FormClosedEventArgs)
            If Not StaxApplication.WindowPositions Is Nothing Then
                StaxApplication.WindowPositions.Save(Me)
            End If

            MyBase.OnFormClosed(e)
        End Sub

        Protected Overrides Sub OnShown(ByVal e As EventArgs)
            If Not HelpIdValue Is Nothing AndAlso Not DesignMode AndAlso _
                StaxApplication.ShowInitialHelp AndAlso _
                Not StaxApplication.StringList Is Nothing AndAlso _
                Not StaxApplication.StringList.Contains(HelpIdValue) Then

                StaxApplication.StringList.Add(HelpIdValue)
                OnHelpRequested(New HelpEventArgs(MousePosition))
            End If

            MyBase.OnShown(e)
        End Sub

        Private ShowLineValue As Boolean = True

        <DefaultValue(True)> _
        Public Property ShowLine() As Boolean
            Get
                Return ShowLineValue
            End Get
            Set(ByVal Value As Boolean)
                ShowLineValue = Value
                DialogButtonsControl.LineControl.Visible = ShowLineValue

                If ShowLineValue Then
                    DialogButtonsControl.Height = 52
                Else
                    DialogButtonsControl.Height = 42
                End If
            End Set
        End Property

        <Browsable(False), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
        Public ReadOnly Property DialogButtons() As DialogButtons
            Get
                Return DialogButtonsControl
            End Get
        End Property

        Public Sub SetTypeTitleHelpId()
            HelpIdValue = Me.GetType.FullName + Text
        End Sub

        Private HelpIdValue As String = Me.GetType.FullName

        <Browsable(False), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
        Public Property HelpId() As String
            Get
                Return HelpIdValue
            End Get
            Set(ByVal Value As String)
                HelpIdValue = Value
            End Set
        End Property

        Private Sub DialogBase_Load() Handles Me.Load
            If Not StaxApplication.WindowPositions Is Nothing Then
                StaxApplication.WindowPositions.RestorePosition(Me)
            End If
        End Sub
    End Class
End Namespace