Namespace UI
    Public Class InputBox
        Private TextValue As String

        Public Property Text() As String
            Get
                Return TextValue
            End Get
            Set(ByVal Value As String)
                TextValue = Value
            End Set
        End Property

        Private TitleValue As String

        Public Property Title() As String
            Get
                If TitleValue Is Nothing Then
                    TitleValue = Application.ProductName
                End If

                Return TitleValue
            End Get
            Set(ByVal Value As String)
                TitleValue = Value
            End Set
        End Property

        Private ValueValue As String

        Public Property Value() As String
            Get
                Return ValueValue
            End Get
            Set(ByVal Value As String)
                ValueValue = Value
            End Set
        End Property

        Private OwnerValue As IWin32Window

        Public Property Owner() As IWin32Window
            Get
                Return OwnerValue
            End Get
            Set(ByVal Value As IWin32Window)
                OwnerValue = Value
            End Set
        End Property

        Private StartPositionValue As FormStartPosition = FormStartPosition.CenterParent

        Public Property StartPosition() As FormStartPosition
            Get
                If Process.GetCurrentProcess.MainWindowHandle = IntPtr.Zero Then
                    StartPositionValue = FormStartPosition.CenterScreen
                End If

                Return StartPositionValue
            End Get
            Set(ByVal Value As FormStartPosition)
                StartPositionValue = Value
            End Set
        End Property

        Public Shared Function Show(ByVal text As String) As String
            Return Show(text, Application.ProductName)
        End Function

        Public Shared Function Show( _
            ByVal text As String, _
            ByVal title As String) As String

            Return Show(text, title, "", FormStartPosition.CenterParent)
        End Function

        Public Shared Function Show( _
            ByVal text As String, _
            ByVal title As String, _
            ByVal value As String) As String

            Return Show(text, title, value, FormStartPosition.CenterParent)
        End Function

        Public Shared Function Show( _
            ByVal text As String, _
            ByVal title As String, _
            ByVal value As String, _
            ByVal startPos As FormStartPosition) As String

            Dim b As New InputBox
            b.Text = text
            b.Title = title
            b.Value = value
            b.StartPosition = startPos

            If b.Show = DialogResult.OK Then
                Return b.Value
            Else
                Return Nothing
            End If
        End Function

        Public Function Show() As DialogResult
            Using f As New InputBoxForm
                f.lPrompt.Text = Text
                f.tbInput.Text = Value
                f.Text = Title
                f.StartPosition = StartPosition

                Dim ret As DialogResult

                If Not Owner Is Nothing Then
                    ret = f.ShowDialog(Owner)
                Else
                    ret = f.ShowDialog()
                End If

                Value = f.tbInput.Text

                Return ret
            End Using
        End Function
    End Class
End Namespace