Namespace UI
    Public Class ListEditor
        Inherits DialogBase

#Region " Designer "

        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub
        Public WithEvents epg As Stax.UI.ExtendedPropertyGrid
        Public WithEvents lbc As Stax.UI.ListBoxControl
        Friend WithEvents LayoutPanel As System.Windows.Forms.TableLayoutPanel

        Private components As System.ComponentModel.IContainer

        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.epg = New Stax.UI.ExtendedPropertyGrid
            Me.lbc = New Stax.UI.ListBoxControl
            Me.LayoutPanel = New System.Windows.Forms.TableLayoutPanel
            Me.LayoutPanel.SuspendLayout()
            Me.SuspendLayout()
            '
            'epg
            '
            Me.epg.Dock = System.Windows.Forms.DockStyle.Fill
            Me.epg.Location = New System.Drawing.Point(282, 3)
            Me.epg.Name = "epg"
            Me.epg.Size = New System.Drawing.Size(335, 332)
            Me.epg.TabIndex = 4
            Me.epg.ToolbarVisible = False
            '
            'lbc
            '
            Me.lbc.Dock = System.Windows.Forms.DockStyle.Fill
            Me.lbc.Location = New System.Drawing.Point(0, 0)
            Me.lbc.Margin = New System.Windows.Forms.Padding(0)
            Me.lbc.Name = "lbc"
            Me.lbc.ShowEditButton = False
            Me.lbc.Size = New System.Drawing.Size(279, 338)
            Me.lbc.TabIndex = 5
            '
            'LayoutPanel
            '
            Me.LayoutPanel.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.LayoutPanel.ColumnCount = 2
            Me.LayoutPanel.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 45.0!))
            Me.LayoutPanel.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 55.0!))
            Me.LayoutPanel.Controls.Add(Me.lbc, 0, 0)
            Me.LayoutPanel.Controls.Add(Me.epg, 1, 0)
            Me.LayoutPanel.Location = New System.Drawing.Point(9, 9)
            Me.LayoutPanel.Margin = New System.Windows.Forms.Padding(0)
            Me.LayoutPanel.Name = "LayoutPanel"
            Me.LayoutPanel.RowCount = 1
            Me.LayoutPanel.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100.0!))
            Me.LayoutPanel.Size = New System.Drawing.Size(620, 338)
            Me.LayoutPanel.TabIndex = 6
            '
            'ListEditor
            '
            Me.ClientSize = New System.Drawing.Size(638, 389)
            Me.Controls.Add(Me.LayoutPanel)
            Me.HelpButton = False
            Me.Name = "ListEditor"
            Me.ShowLine = False
            Me.Text = "Collection Editor"
            Me.Controls.SetChildIndex(Me.LayoutPanel, 0)
            Me.LayoutPanel.ResumeLayout(False)
            Me.ResumeLayout(False)

        End Sub

#End Region

        Private Items As IList

        Public Sub New(ByVal items As IList)
            MyBase.New()
            InitializeComponent()
            AddHandler lbc.ListBox.SelectedIndexChanged, AddressOf ItemSelectedIndexChanged

            Me.Items = items

            For Each i As Object In DirectCast(ObjectHelp.GetCopy(items), IList)
                lbc.ListBox.Items.Add(i)
            Next
        End Sub

        Public Sub ItemSelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
            epg.SelectedObject = lbc.ListBox.SelectedItem
        End Sub

        Private TypeValue As Type

        Public Property ItemType() As Type
            Get
                Return TypeValue
            End Get
            Set(ByVal Value As Type)
                TypeValue = Value
            End Set
        End Property

        Private Sub lbc_ButtonClickAdd() Handles lbc.ButtonClickAdd
            Dim item As Object = Activator.CreateInstance(ItemType)
            lbc.ListBox.SelectedIndex = lbc.ListBox.Items.Add(item)
        End Sub

        Private Sub epg_PropertyValueChanged(ByVal s As Object, ByVal e As PropertyValueChangedEventArgs) Handles epg.PropertyValueChanged
            lbc.ListBox.UpdateSelection()
        End Sub

        Private Sub ListEditor_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed
            If DialogResult = Windows.Forms.DialogResult.OK Then
                Items.Clear()

                For Each i As Object In lbc.ListBox.Items
                    Items.Add(i)
                Next
            End If
        End Sub

        Private Sub ListEditor_Shown() Handles Me.Shown
            PropertyGridHelp.MoveSplitter(epg, 100)
        End Sub
    End Class
End Namespace