Imports Stax.AppFramework

Namespace UI
    Public Class MenuTemplateForm
        Inherits DialogBase

#Region " Designer "
        Friend WithEvents tv As System.Windows.Forms.TreeView
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.tv = New System.Windows.Forms.TreeView
            Me.SuspendLayout()
            '
            'tv
            '
            Me.tv.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.tv.Location = New System.Drawing.Point(12, 13)
            Me.tv.Name = "tv"
            Me.tv.Size = New System.Drawing.Size(356, 361)
            Me.tv.TabIndex = 0
            '
            'MenuTemplateForm
            '
            Me.ClientSize = New System.Drawing.Size(380, 419)
            Me.Controls.Add(Me.tv)
            Me.Name = "MenuTemplateForm"
            Me.ShowLine = False
            Me.Text = "Default Menu"
            Me.Controls.SetChildIndex(Me.tv, 0)
            Me.ResumeLayout(False)

        End Sub

#End Region

        Public TreeNode As TreeNode

        Public Sub New(ByVal item As CustomMenuItem)
            MyBase.New()
            InitializeComponent()
            PopulateTreeView(item, Nothing)
            tv.ExpandAll()
        End Sub

        Private Sub PopulateTreeView(ByVal item As CustomMenuItem, ByVal node As TreeNode)
            Dim newNode As New TreeNode(item.Text)
            newNode.Tag = item

            If node Is Nothing Then
                tv.Nodes.Add(newNode)
            Else
                node.Nodes.Add(newNode)
            End If

            For Each i As CustomMenuItem In item.SubItems
                PopulateTreeView(i, newNode)
            Next
        End Sub

        Private Sub tv_AfterSelect(ByVal sender As Object, ByVal e As TreeViewEventArgs) Handles tv.AfterSelect
            If Not tv.SelectedNode Is Nothing Then
                TreeNode = tv.SelectedNode
                DialogButtons.bOK.Enabled = Not TreeNode.Parent Is Nothing
            End If
        End Sub

        Private Sub MenuTemplateForm_HelpRequested(ByVal sender As Object, ByVal hlpevent As HelpEventArgs) Handles Me.HelpRequested
            Dim f As New HelpForm()
            f.Doc.WriteStart(Text)
            f.Doc.WriteP("The new item will be a clone of the selected item.")
            f.Show()
        End Sub
    End Class
End Namespace