Imports Stax.UI

Public Class SelectionBox(Of T)
    Private Items As New List(Of Object)

    Public SelectedItem As T
    Public Text As String
    Public Title As String

    Public Sub AddItem(ByVal text As String, ByVal item As T)
        Items.Add(New ListBag(Of T)(text, item))
    End Sub

    Public Sub AddItem(ByVal item As T)
        Items.Add(item)
    End Sub

    Public Function Show() As DialogResult
        Using Form As New SelectionBoxForm
            If Items.Count > 0 Then
                Form.cbItems.Items.AddRange(Items.ToArray)

                If Not SelectedItem Is Nothing Then
                    Form.cbItems.SelectedItem = SelectedItem
                End If

                If Form.cbItems.SelectedIndex = -1 Then
                    Form.cbItems.SelectedIndex = 0
                End If
            End If

            Form.Text = Title

            If Not OK(Form.Text) Then
                Form.Text = Application.ProductName
            End If

            Form.lText.Text = Text

            Dim ret As DialogResult = Form.ShowDialog

            If TypeOf Form.cbItems.SelectedItem Is ListBag(Of T) Then
                SelectedItem = ListBag(Of T).GetValue(Form.cbItems)
            Else
                SelectedItem = DirectCast(Form.cbItems.SelectedItem, T)
            End If

            Return ret
        End Using
    End Function
End Class