Namespace UI
    Public Class WizardForm
        Inherits Form

#Region " Designer "

        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

        Private components As System.ComponentModel.IContainer

        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.SuspendLayout()
            '
            'WizardForm
            '
            Me.ClientSize = New System.Drawing.Size(440, 281)
            Me.ControlBox = False
            Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
            Me.MaximizeBox = False
            Me.MinimizeBox = False
            Me.Name = "WizardForm"
            Me.ShowIcon = False
            Me.ShowInTaskbar = False
            Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
            Me.Text = "Title"
            Me.ResumeLayout(False)

        End Sub

#End Region

        Private PagesValue As New List(Of WizardPageBase)
        Private CurrentPage As WizardPageBase

        Public Sub New()
            MyBase.New()
            InitializeComponent()
        End Sub

        Public ReadOnly Property Pages() As List(Of WizardPageBase)
            Get
                Return PagesValue
            End Get
        End Property

        Public Sub AddPage(ByVal page As WizardPageBase)
            page.Visible = False
            page.WizardForm = Me
            page.BackColor = Color.White
            page.Dock = DockStyle.Fill

            If page.Width > ClientSize.Width Then
                ClientSize = New Size(page.Width, ClientSize.Height)
            End If

            If page.Height > ClientSize.Height Then
                ClientSize = New Size(ClientSize.Width, page.Height)
            End If

            Controls.Add(page)
            PagesValue.Add(page)
        End Sub

        Private Sub WizardForm_Load() Handles Me.Load
            PagesValue(0).Visible = True
            CurrentPage = PagesValue(0)
        End Sub

        Public Sub NextPage()
            If CurrentPage Is PagesValue(PagesValue.Count - 1) Then
                DialogResult = Windows.Forms.DialogResult.OK
            Else
                CurrentPage.Visible = False
                CurrentPage = PagesValue(PagesValue.IndexOf(CurrentPage) + 1)
                CurrentPage.Visible = True
            End If
        End Sub
    End Class
End Namespace