﻿Imports Stax.UI
Imports System.Text
Imports System.ComponentModel

Public Class CmdlControl
    Inherits System.Windows.Forms.UserControl

#Region "Designer"
    Friend WithEvents tb As ExtendedTextbox
    Friend WithEvents bCmdlAddition As Stax.UI.ExtendedButton

    Public Sub New()
        InitializeComponent()
    End Sub

    <System.Diagnostics.DebuggerNonUserCode()> _
    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        Try
            If disposing AndAlso components IsNot Nothing Then
                components.Dispose()
            End If
        Finally
            MyBase.Dispose(disposing)
        End Try
    End Sub

    Private components As System.ComponentModel.IContainer

    <System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        Me.tb = New ExtendedTextbox
        Me.bCmdlAddition = New Stax.UI.ExtendedButton
        Me.SuspendLayout()
        '
        'tb
        '
        Me.tb.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tb.Location = New System.Drawing.Point(3, 5)
        Me.tb.Multiline = True
        Me.tb.Name = "tb"
        Me.tb.Size = New System.Drawing.Size(307, 67)
        Me.tb.TabIndex = 3
        '
        'bCmdlAddition
        '
        Me.bCmdlAddition.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.bCmdlAddition.DropDownGlyphMode = Stax.UI.DropDownGlyphMode.Center
        Me.bCmdlAddition.Location = New System.Drawing.Point(316, 3)
        Me.bCmdlAddition.Size = New System.Drawing.Size(24, 24)
        '
        'CmdlControl
        '
        Me.AutoScaleDimensions = New System.Drawing.SizeF(6.0!, 13.0!)
        Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font
        Me.Controls.Add(Me.tb)
        Me.Controls.Add(Me.bCmdlAddition)
        Me.Name = "CmdlControl"
        Me.Size = New System.Drawing.Size(343, 77)
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub
#End Region

    Private ProfileValue As String
    Private HelpFileValue As String
    Private cms As ContextMenuStrip

    Public Event PresetsChanged(ByVal presets As String)

    Private EditorTextValue As String

    Public Property EditorText() As String
        Get
            Return EditorTextValue
        End Get
        Set(ByVal Value As String)
            EditorTextValue = Value
        End Set
    End Property

    <Browsable(False), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Property Presets() As String
        Get
            Return ProfileValue
        End Get
        Set(ByVal Value As String)
            ProfileValue = Value
        End Set
    End Property

    <Browsable(False)> _
    ReadOnly Property TextBox() As TextBox
        Get
            Return tb
        End Get
    End Property

    Public Sub MenuItenClick(ByVal value As String)
        If tb.Text = "" Then
            tb.Text = Macro.Solve(value, False)
        Else
            tb.Text = tb.Text.Trim + " " + Macro.Solve(value, False)
        End If
    End Sub

    Public Sub EditPresets()
        Using f As New MacroEditor
            f.SetMacroDefaults()
            f.MacroEditorControl.Value = Presets.FormatColumn("=").FormatColumn("#")
            f.AutoResize()

            If Not EditorText Is Nothing Then
                f.Text = EditorText
            End If

            If f.ShowDialog() = DialogResult.OK Then
                Presets = f.MacroEditorControl.Value.FixBreak.ReplaceUnicode
                RaiseEvent PresetsChanged(Presets)
            End If
        End Using
    End Sub

    Private Sub bCmdlAddition_Click() Handles bCmdlAddition.Click
        Try
            If components Is Nothing Then
                components = New System.ComponentModel.Container
            End If

            If cms Is Nothing Then
                cms = New ContextMenuStrip(components)
            End If

            cms.Items.Clear()

            For Each i In Presets.SplitLines
                If i.Contains("=") AndAlso Not i.StartsWith("#") Then
                    Dim arg = ""

                    If i.Contains("#") Then
                        arg = i.Right("=").Trim.Left("#").Trim
                    Else
                        arg = i.Right("=").Trim
                    End If

                    ParamToolStripMenuItem(Of String).Populate(cms.Items, i.Left("=").Trim, AddressOf MenuItenClick, arg, Keys.None, i.Right("#").Trim)
                End If
            Next

            cms.Items.Add(New ToolStripSeparator)
            cms.Items.Add(New SubToolStripMenuItem("Edit Presets...", AddressOf EditPresets))
            cms.Show(bCmdlAddition, 0, bCmdlAddition.Height)
        Catch ex As Exception
            Msg.Show("Failed to build menu.", MsgIcon.Error)
        End Try
    End Sub
End Class