Imports System.ComponentModel

Imports Stax
Imports Stax.UI
Imports Stax.AppFramework

<ToolboxItem(False)> _
Public Class OptionsAdvancedControl
    Inherits DialogControl

#Region " Designer "

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    Friend WithEvents stv As Stax.UI.SettingTreeView
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.stv = New Stax.UI.SettingTreeView
        Me.SuspendLayout()
        '
        'AdvancedSettingTreeView
        '
        Me.stv.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.stv.AutoCollaps = True
        Me.stv.ExpandMode = TreeNodeExpandMode.InclusiveChilds
        Me.stv.HideSelection = False
        Me.stv.Location = New System.Drawing.Point(11, 31)
        Me.stv.Name = "AdvancedSettingTreeView"
        Me.stv.SelectOnMouseDown = True
        Me.stv.Size = New System.Drawing.Size(370, 288)
        Me.stv.TabIndex = 108
        '
        'OptionsAdvancedControl
        '
        Me.Controls.Add(Me.stv)
        Me.Name = "OptionsAdvancedControl"
        Me.Padding = New System.Windows.Forms.Padding(8, 28, 8, 8)
        Me.Size = New System.Drawing.Size(392, 330)
        Me.Text = "Advanced"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public Sub New()
        MyBase.New()
        InitializeComponent()

        stv.AddBool("Image", "Auto Aspect Ratio Signaling (don't disable!)", p.AutoARSignaling, "In case no resize filter is used or the aspect ratio error exceeds the defined maximal value StaxRip signals the enccoder to write the aspect ratio to the bitstream so players that support aspect ratio signaling playback still the proper aspect ratio. " + Strings.DoNotModifyOption)
        stv.AddBool("Image", "Auto correct crop values (don't disable!)", p.AutoCorrectCropValues, "Forces safe mod values for cropping. " + Strings.DoNotModifyOption)
        stv.AddBool("Image", "Auto crop borders until proper aspect ratio is found", p.AutoSmartCrop, "Automatically crops borders until the proper aspect ratio is found.")
        stv.AddSingle("Image", "Auto overcrop width to limit aspect ratio to", p.AutoSmartOvercrop, "On small devices like the iPod it's recommend to restrict the aspect ratio to " & 1.6 & " and overcrop the width instead.", 0, 2, 0.1)
        stv.AddInt("Image", "Maximum Aspect Ratio Error", p.MaxAspectRatioError, Strings.DoNotModifyOption, 1, 10, 1)
        stv.AddInt("Image", "Maximum Width Of Resize Slider (0 = Source Width)", p.ResizeSliderMaxWidth, Nothing, 0, 1920, 2)
        stv.AddBool("Image", "Use ITU-R BT.601 (don't disable!)", p.ITU, "Calculates the aspect ratio according to ITU-R BT.601 standard where appropriate. " + Strings.DoNotModifyOption)
        stv.AddText("Image", "Custom Source PAR", New FieldSettingBag(Of String)(p, "CustomPAR"), "Custom source pixel aspect ratio.")

        stv.AddSetting(New ComboboxTreeNodeSetting(Of Integer)("Image", "Output Mod (use 16!)", p.ForcedOutputMod, "Value for the output width/height to be a multiple of. " + Strings.DoNotModifyOption, 2, 4, 8, 16))

        stv.AddBool("Assistant", "Remind To Crop", p.RemindToCrop)
        stv.AddBool("Assistant", "Remind To Cut", p.RemindToCut)
        stv.AddBool("Assistant", "Remind To Do Compressibility Check", p.RemindToDoCompCheck)
        stv.AddBool("Assistant", "Remind To Set Filters", p.RemindToSetFilters)
        stv.AddBool("Assistant", "Remind Not To Oversize", p.RemindOversize, "Shows a reminder if the target image size is larger than the source image size. " + Strings.DoNotModifyOption)

        stv.AddBool("Filters", "Use AviSynth to cut mpa/mp2/ac3", p.UseAviSynthToCut, "Uses the AviSynth source filter NicAudio as alternative cutting method. " + Strings.DoNotModifyOption)
        stv.AddSetting(New ScriptEditorTreeNodeSetting("Filters", "Info filter for preview", p.PreviewScript, Nothing))

        stv.AddInt("Misc", "Auto Force Film Threshold (Percent)", p.AutoForceFilmThreshold, "Threshold at which force film is applied automatically. " + Strings.DoNotModifyOption, 0, 101, 1)
        stv.AddInt("Misc", "Percentage to use for compressibility check", p.CompCheckRange, Nothing, 2, 20, 1)
        stv.AddBool("Misc", "Delete temp files directory (not recommended)", New FieldSettingBag(Of Boolean)(p, "DeleteTempFilesDir"))

        stv.Nodes(0).ExpandAll()
    End Sub

    Private Sub OptionsGeneralControl_FormClosingOK() Handles MyBase.FormClosingOK
        stv.Apply()

        If p.CompCheckRange.Value < 2 OrElse p.CompCheckRange.Value > 20 Then
            p.CompCheckRange.Value = 5
        End If

        g.MainForm.SetSlider()
    End Sub

    Private Sub ShowWarning(ByVal message As String)
        If Not s.Storage.GetBool(message.MD5Hash) Then
            Msg.Show(message, MsgIcon.Warning)
            s.Storage.SetBool(message.MD5Hash, True)
        Else
            s.Storage.SetBool(message.MD5Hash, False)
        End If
    End Sub

    Public Overrides Sub ShowHelp()
        Dim f As New HelpForm()
        f.Doc.WriteStart(Text)
        f.Doc.WriteTips(stv.GetTips)
        f.Show()
    End Sub
End Class