Imports Stax
Imports Stax.UI
Imports Stax.AppFramework

Public Class SubtitleControl
    Inherits UserControl

#Region " Designer "
    <DebuggerNonUserCode()> _
    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing AndAlso components IsNot Nothing Then
            components.Dispose()
        End If

        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents gbSubtitles As System.Windows.Forms.GroupBox
    Friend WithEvents lvc As Stax.UI.ListViewControl

    Private components As System.ComponentModel.IContainer

    <DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        Me.gbSubtitles = New System.Windows.Forms.GroupBox
        Me.lvc = New Stax.UI.ListViewControl
        Me.gbSubtitles.SuspendLayout()
        Me.SuspendLayout()
        '
        'gbSubtitles
        '
        Me.gbSubtitles.Controls.Add(Me.lvc)
        Me.gbSubtitles.Dock = System.Windows.Forms.DockStyle.Fill
        Me.gbSubtitles.Location = New System.Drawing.Point(0, 0)
        Me.gbSubtitles.Name = "gbSubtitles"
        Me.gbSubtitles.Size = New System.Drawing.Size(451, 144)
        Me.gbSubtitles.TabIndex = 3
        Me.gbSubtitles.TabStop = False
        Me.gbSubtitles.Text = "Subtitles"
        '
        'lvc
        '
        Me.lvc.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lvc.Location = New System.Drawing.Point(6, 19)
        Me.lvc.Name = "lvc"
        Me.lvc.ShowEditButton = False
        Me.lvc.Size = New System.Drawing.Size(439, 119)
        Me.lvc.TabIndex = 4
        '
        'SubtitleControl
        '
        Me.AutoScaleDimensions = New System.Drawing.SizeF(6.0!, 13.0!)
        Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font
        Me.Controls.Add(Me.gbSubtitles)
        Me.Name = "SubtitleControl"
        Me.Size = New System.Drawing.Size(451, 144)
        Me.gbSubtitles.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public Sub New()
        MyBase.New()
        InitializeComponent()

        lvc.lv.SmallImageList = New ImageList() With {.ImageSize = New Size(20, 20)}

        lvc.lv.Columns.Add("Dummy", 0)
        lvc.lv.Columns.Add("Language", 102)
        lvc.lv.Columns.Add("Name", 104)
        lvc.lv.Columns.Add("Path", 300)

        lvc.lv.AddTextBox(2)
        lvc.lv.AddComboBox(Language.Languages, 1).DropDownStyle = ComboBoxStyle.DropDownList

        AddHandler lvc.lv.Edited, AddressOf ListViewEdited
        AddHandler lvc.lv.BeforeShowControl, AddressOf ListViewBeforeShowControl
    End Sub

    Protected Overrides Sub OnLayout(ByVal e As LayoutEventArgs)
        MyBase.OnLayout(e)
        Dim c = lvc.lv.Columns
        Dim w = lvc.lv.Width - c(1).Width - 25
        c(2).Width = CInt(w * 0.4)
        c(3).Width = CInt(w * 0.6)
    End Sub

    Public Sub AddSubtitles(ByVal subtitles As List(Of Subtitle))
        For Each i In subtitles
            Dim item = New ListViewItem(New String() {"", i.Language.ToString, i.Name, i.Path})
            item.Tag = i
            lvc.lv.Items.Add(item)
        Next

        If lvc.lv.Items.Count > 0 Then
            lvc.lv.Items(lvc.lv.Items.Count - 1).Selected = True
        End If

        lvc.UpdateControls()
    End Sub

    Public Sub SetValues(ByVal muxer As Muxer)
        muxer.Subtitles2.Clear()

        For Each i As ListViewItem In lvc.lv.Items
            muxer.Subtitles2.Add(DirectCast(i.Tag, Subtitle))
        Next
    End Sub

    Private Sub ListViewBeforeShowControl(ByVal e As BeforeShowControlEventArgs)
        Dim subtitle = DirectCast(lvc.lv.Items(e.Position.Y).Tag, Subtitle)

        If e.Position.X = 1 AndAlso Filepath.GetExt(subtitle.Path) = ".idx" Then
            e.Cancel = True
        End If
    End Sub

    Private Sub ListViewEdited(ByVal value As Object, ByVal pos As Point)
        Dim subtitle = DirectCast(lvc.lv.Items(pos.Y).Tag, Subtitle)

        Select Case pos.X
            Case 1
                subtitle.Language = DirectCast(value, Language)
            Case 2
                subtitle.Name = value.ToString
        End Select
    End Sub

    Private Sub lvc_ButtonClickAdd() Handles lvc.ButtonClickAdd
        Using d As New OpenFileDialog
            d.Filter = "Subtitle Files|*.idx;*.srt;*.ssa;*.smi;*.ass;*.ttxt|All Files|*.*"
            d.Multiselect = True

            If Directory.Exists(s.LastSourceDir) Then
                d.InitialDirectory = s.LastSourceDir
            End If

            If d.ShowDialog = DialogResult.OK Then
                For Each i In d.FileNames
                    AddSubtitles(Subtitle.Create(i))
                Next

                PopUp.ShowOnce(lvc.lv, "Double-click properties to edit.")
            End If
        End Using
    End Sub
End Class