Imports System.Reflection

Imports Stax
Imports Stax.UI
Imports Stax.AppFramework
Imports Stax.DynamicObject
Imports Stax.ComponentModel

Public Class EventCommandEditor
    Inherits DialogBase

#Region " Designer "

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Friend WithEvents tbName As System.Windows.Forms.TextBox
    Friend WithEvents cbEvent As System.Windows.Forms.ComboBox
    Friend WithEvents TipProvider As Stax.UI.TipProvider
    Friend WithEvents CriteriaControl As Stax.UI.CriteriaControl
    Friend WithEvents tbCommand As System.Windows.Forms.TextBox
    Friend WithEvents bCommand As Stax.UI.ExtendedButton
    Friend WithEvents cmsCommands As System.Windows.Forms.ContextMenuStrip
    Friend WithEvents pgParameters As System.Windows.Forms.PropertyGrid
    Friend WithEvents lCommandParameters As System.Windows.Forms.Label
    Friend WithEvents rbMatchAllCriteria As System.Windows.Forms.RadioButton
    Friend WithEvents rbMatchAnyCriteria As System.Windows.Forms.RadioButton
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox3 As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox4 As System.Windows.Forms.GroupBox
    Friend WithEvents FormInitLabel1 As Stax.UI.Design.ActionListInitLabel

    Private components As System.ComponentModel.IContainer

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.tbName = New System.Windows.Forms.TextBox
        Me.cbEvent = New System.Windows.Forms.ComboBox
        Me.tbCommand = New System.Windows.Forms.TextBox
        Me.bCommand = New Stax.UI.ExtendedButton
        Me.cmsCommands = New System.Windows.Forms.ContextMenuStrip(Me.components)
        Me.CriteriaControl = New Stax.UI.CriteriaControl
        Me.TipProvider = New Stax.UI.TipProvider(Me.components)
        Me.pgParameters = New System.Windows.Forms.PropertyGrid
        Me.rbMatchAllCriteria = New System.Windows.Forms.RadioButton
        Me.rbMatchAnyCriteria = New System.Windows.Forms.RadioButton
        Me.lCommandParameters = New System.Windows.Forms.Label
        Me.GroupBox1 = New System.Windows.Forms.GroupBox
        Me.GroupBox2 = New System.Windows.Forms.GroupBox
        Me.GroupBox3 = New System.Windows.Forms.GroupBox
        Me.GroupBox4 = New System.Windows.Forms.GroupBox
        Me.FormInitLabel1 = New Stax.UI.Design.ActionListInitLabel
        CType(Me.TipProvider, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.GroupBox1.SuspendLayout()
        Me.GroupBox2.SuspendLayout()
        Me.GroupBox3.SuspendLayout()
        Me.GroupBox4.SuspendLayout()
        Me.SuspendLayout()
        '
        'tbName
        '
        Me.tbName.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tbName.Location = New System.Drawing.Point(6, 19)
        Me.tbName.Name = "tbName"
        Me.tbName.Size = New System.Drawing.Size(248, 20)
        Me.tbName.TabIndex = 3
        Me.TipProvider.SetTipName(Me.tbName, "Name")
        Me.TipProvider.SetTipText(Me.tbName, "Name of the Event Command.")
        '
        'cbEvent
        '
        Me.cbEvent.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.cbEvent.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cbEvent.FormattingEnabled = True
        Me.cbEvent.Location = New System.Drawing.Point(6, 18)
        Me.cbEvent.Name = "cbEvent"
        Me.cbEvent.Size = New System.Drawing.Size(263, 21)
        Me.cbEvent.Sorted = True
        Me.cbEvent.TabIndex = 5
        Me.TipProvider.SetTipName(Me.cbEvent, "Event")
        Me.TipProvider.SetTipText(Me.cbEvent, "The event on which the command gets executed.")
        '
        'tbCommand
        '
        Me.tbCommand.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tbCommand.Location = New System.Drawing.Point(6, 19)
        Me.tbCommand.Name = "tbCommand"
        Me.tbCommand.ReadOnly = True
        Me.tbCommand.Size = New System.Drawing.Size(254, 20)
        Me.tbCommand.TabIndex = 10
        Me.TipProvider.SetTipName(Me.tbCommand, "Command")
        Me.TipProvider.SetTipText(Me.tbCommand, "Command to be executed.")
        '
        'bCommand
        '
        Me.bCommand.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.bCommand.ContextMenuStrip = Me.cmsCommands
        Me.bCommand.DropDownGlyphMode = Stax.UI.DropDownGlyphMode.Center
        Me.bCommand.Location = New System.Drawing.Point(266, 17)
        Me.bCommand.ShowMenuOnClick = True
        Me.bCommand.Size = New System.Drawing.Size(24, 24)
        '
        'cmsCommands
        '
        Me.cmsCommands.Name = "cmsCommands"
        Me.cmsCommands.Size = New System.Drawing.Size(61, 4)
        '
        'CriteriaControl
        '
        Me.CriteriaControl.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.CriteriaControl.BackColor = System.Drawing.SystemColors.Window
        Me.CriteriaControl.Location = New System.Drawing.Point(6, 42)
        Me.CriteriaControl.Name = "CriteriaControl"
        Me.CriteriaControl.ShowNiceBorder = True
        Me.CriteriaControl.Size = New System.Drawing.Size(528, 120)
        Me.CriteriaControl.TabIndex = 7
        Me.TipProvider.SetTipName(Me.CriteriaControl, "Criteria")
        Me.TipProvider.SetTipText(Me.CriteriaControl, "Criteria can be defined optionally to execute the command only if the criteria is" & _
                " matched.")
        '
        'pgParameters
        '
        Me.pgParameters.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.pgParameters.Location = New System.Drawing.Point(6, 65)
        Me.pgParameters.Name = "pgParameters"
        Me.pgParameters.PropertySort = System.Windows.Forms.PropertySort.Alphabetical
        Me.pgParameters.Size = New System.Drawing.Size(254, 167)
        Me.pgParameters.TabIndex = 12
        Me.TipProvider.SetTipName(Me.pgParameters, "Command Parameters")
        Me.TipProvider.SetTipText(Me.pgParameters, "Parameters used to execute the command.")
        Me.pgParameters.ToolbarVisible = False
        '
        'rbMatchAllCriteria
        '
        Me.rbMatchAllCriteria.AutoSize = True
        Me.rbMatchAllCriteria.Location = New System.Drawing.Point(6, 19)
        Me.rbMatchAllCriteria.Name = "rbMatchAllCriteria"
        Me.rbMatchAllCriteria.Size = New System.Drawing.Size(69, 17)
        Me.rbMatchAllCriteria.TabIndex = 14
        Me.rbMatchAllCriteria.TabStop = True
        Me.rbMatchAllCriteria.Text = "Match All"
        Me.TipProvider.SetTipText(Me.rbMatchAllCriteria, "Command gets only executed if all criteria is true.")
        Me.rbMatchAllCriteria.UseVisualStyleBackColor = True
        '
        'rbMatchAnyCriteria
        '
        Me.rbMatchAnyCriteria.AutoSize = True
        Me.rbMatchAnyCriteria.Location = New System.Drawing.Point(81, 19)
        Me.rbMatchAnyCriteria.Name = "rbMatchAnyCriteria"
        Me.rbMatchAnyCriteria.Size = New System.Drawing.Size(76, 17)
        Me.rbMatchAnyCriteria.TabIndex = 15
        Me.rbMatchAnyCriteria.TabStop = True
        Me.rbMatchAnyCriteria.Text = "Match Any"
        Me.TipProvider.SetTipText(Me.rbMatchAnyCriteria, "Command gets executed if any criteria is true.")
        Me.rbMatchAnyCriteria.UseVisualStyleBackColor = True
        '
        'lCommandParameters
        '
        Me.lCommandParameters.AutoSize = True
        Me.lCommandParameters.Location = New System.Drawing.Point(6, 49)
        Me.lCommandParameters.Name = "lCommandParameters"
        Me.lCommandParameters.Size = New System.Drawing.Size(63, 13)
        Me.lCommandParameters.TabIndex = 13
        Me.lCommandParameters.Text = "Parameters:"
        '
        'GroupBox1
        '
        Me.GroupBox1.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.GroupBox1.Controls.Add(Me.CriteriaControl)
        Me.GroupBox1.Controls.Add(Me.rbMatchAnyCriteria)
        Me.GroupBox1.Controls.Add(Me.rbMatchAllCriteria)
        Me.GroupBox1.Location = New System.Drawing.Point(12, 71)
        Me.GroupBox1.Name = "GroupBox1"
        Me.GroupBox1.Size = New System.Drawing.Size(540, 168)
        Me.GroupBox1.TabIndex = 16
        Me.GroupBox1.TabStop = False
        Me.GroupBox1.Text = "Criteria"
        '
        'GroupBox2
        '
        Me.GroupBox2.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.GroupBox2.Controls.Add(Me.pgParameters)
        Me.GroupBox2.Controls.Add(Me.tbCommand)
        Me.GroupBox2.Controls.Add(Me.bCommand)
        Me.GroupBox2.Controls.Add(Me.lCommandParameters)
        Me.GroupBox2.Location = New System.Drawing.Point(12, 245)
        Me.GroupBox2.Name = "GroupBox2"
        Me.GroupBox2.Size = New System.Drawing.Size(540, 238)
        Me.GroupBox2.TabIndex = 17
        Me.GroupBox2.TabStop = False
        Me.GroupBox2.Text = "Command"
        '
        'GroupBox3
        '
        Me.GroupBox3.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.GroupBox3.Controls.Add(Me.tbName)
        Me.GroupBox3.Location = New System.Drawing.Point(12, 12)
        Me.GroupBox3.Name = "GroupBox3"
        Me.GroupBox3.Size = New System.Drawing.Size(260, 53)
        Me.GroupBox3.TabIndex = 18
        Me.GroupBox3.TabStop = False
        Me.GroupBox3.Text = "Name"
        '
        'GroupBox4
        '
        Me.GroupBox4.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.GroupBox4.Controls.Add(Me.cbEvent)
        Me.GroupBox4.Location = New System.Drawing.Point(278, 12)
        Me.GroupBox4.Name = "GroupBox4"
        Me.GroupBox4.Size = New System.Drawing.Size(275, 53)
        Me.GroupBox4.TabIndex = 19
        Me.GroupBox4.TabStop = False
        Me.GroupBox4.Text = "Event"
        '
        'FormInitLabel1
        '
        Me.FormInitLabel1.AutoSize = True
        Me.FormInitLabel1.Dummy = False
        Me.FormInitLabel1.Location = New System.Drawing.Point(-300, 245)
        Me.FormInitLabel1.Size = New System.Drawing.Size(76, 13)
        Me.FormInitLabel1.Text = "FormInitLabel1"
        '
        'EventCommandEditor
        '
        Me.ClientSize = New System.Drawing.Size(564, 529)
        Me.Controls.Add(Me.FormInitLabel1)
        Me.Controls.Add(Me.GroupBox4)
        Me.Controls.Add(Me.GroupBox2)
        Me.Controls.Add(Me.GroupBox3)
        Me.Controls.Add(Me.GroupBox1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Sizable
        Me.MinimumSize = New System.Drawing.Size(521, 487)
        Me.Name = "EventCommandEditor"
        Me.ShowLine = False
        Me.Text = "Event Command Editor"
        Me.Controls.SetChildIndex(Me.GroupBox1, 0)
        Me.Controls.SetChildIndex(Me.GroupBox3, 0)
        Me.Controls.SetChildIndex(Me.GroupBox2, 0)
        Me.Controls.SetChildIndex(Me.GroupBox4, 0)
        Me.Controls.SetChildIndex(Me.FormInitLabel1, 0)
        CType(Me.TipProvider, System.ComponentModel.ISupportInitialize).EndInit()
        Me.GroupBox1.ResumeLayout(False)
        Me.GroupBox1.PerformLayout()
        Me.GroupBox2.ResumeLayout(False)
        Me.GroupBox2.PerformLayout()
        Me.GroupBox3.ResumeLayout(False)
        Me.GroupBox3.PerformLayout()
        Me.GroupBox4.ResumeLayout(False)
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Private GridTypeDescriptor As New GridTypeDescriptor
    Private CommandParameters As CommandParameters
    Private EventCommandValue As EventCommand

    Public Sub New(ByVal ev As EventCommand)
        MyBase.New()
        InitializeComponent()

        EventCommandValue = ev
        tbName.Text = EventCommandValue.Name

        cbEvent.Items.AddRange(ListBag(Of ApplicationEvent).GetBagsForEnumType)
        ListBag(Of ApplicationEvent).SelectItem(cbEvent, EventCommandValue.Event)

        rbMatchAllCriteria.Checked = Not ev.OrOnly
        rbMatchAnyCriteria.Checked = ev.OrOnly

        Dim allCriteria As New List(Of Criteria)

        For Each i In Macro.GetMacros()
            Dim c = Criteria.Create(i.Type)
            c.Name = i.FriendlyName
            c.Macro = i.Name
            allCriteria.Add(c)
        Next

        CriteriaControl.AllCrieria = allCriteria
        CriteriaControl.CriteriaList = EventCommandValue.CriteriaList

        If Not EventCommandValue.CommandParameters Is Nothing Then
            CommandParameters = DirectCast(ObjectHelp.GetCopy(EventCommandValue.CommandParameters), CommandParameters)
        End If

        SetCommandParameters(CommandParameters)
        Command.PopulateCommandMenu(cmsCommands.Items, New List(Of Command)(g.MainForm.CustomMainMenu.CommandManager.Commands.Values), AddressOf MenuClick)

        For Each i As ToolStripMenuItem In cmsCommands.Items
            If i.Text = "Dynamic" Then
                i.Visible = False
            End If
        Next
    End Sub

    Private Sub MenuClick(ByVal c As Command)
        CommandParameters = New CommandParameters(c.MethodInfo.Name, c.GetDefaultParameters.ToArray)
        SetCommandParameters(CommandParameters)
    End Sub

    Private Sub SetCommandParameters(ByVal cp As CommandParameters)
        If cp Is Nothing Then
            pgParameters.Visible = False
            lCommandParameters.Visible = False
            Exit Sub
        End If

        Dim cm = g.MainForm.CustomMainMenu.CommandManager

        If Not cm.HasCommand(cp.MethodName) Then
            pgParameters.Visible = False
            lCommandParameters.Visible = False
            Exit Sub
        End If

        Dim c = g.MainForm.CustomMainMenu.CommandManager.GetCommand(cp.MethodName)
        tbCommand.Text = c.Attribute.Name

        If cp.Parameters Is Nothing OrElse cp.Parameters.Count = 0 Then
            pgParameters.Visible = False
            lCommandParameters.Visible = False
            Exit Sub
        End If

        Dim mi = c.MethodInfo

        If mi Is Nothing Then
            pgParameters.Visible = False
            lCommandParameters.Visible = False
            Exit Sub
        End If

        pgParameters.Visible = True
        lCommandParameters.Visible = True

        GridTypeDescriptor.Items.Clear()

        Dim params = mi.GetParameters

        For i = 0 To params.Length - 1
            Dim gp As New GridProperty
            gp.Name = DisplayInfoAttribute.GetValue(params(i).GetCustomAttributes(False))

            If gp.Name Is Nothing Then
                gp.Name = params(i).Name.ToTitleCase
            End If

            gp.Value = c.FixParameters(cp.Parameters)(i)
            gp.Description = DescriptionAttributeHelp.GetDescription(params(i).GetCustomAttributes(False))
            gp.TypeEditor = EditorAttributeHelp.GetEditor(params(i).GetCustomAttributes(False))

            GridTypeDescriptor.Add(gp)
        Next

        pgParameters.SelectedObject = GridTypeDescriptor
        PropertyGridHelp.MoveSplitter(pgParameters, 120)
    End Sub

    Private Sub EventCommandEditor_FormClosed() Handles Me.FormClosed
        If DialogResult = DialogResult.OK Then
            EventCommandValue.Name = tbName.Text
            EventCommandValue.Event = ListBag(Of ApplicationEvent).GetValue(cbEvent)
            EventCommandValue.CriteriaList = CriteriaControl.CriteriaList
            EventCommandValue.CommandParameters = CommandParameters
            EventCommandValue.OrOnly = rbMatchAnyCriteria.Checked
        End If
    End Sub

    Private Sub EventCommandEditor_HelpRequested() Handles Me.HelpRequested
        Dim f As New HelpForm()
        f.Doc.WriteStart(Text)
        f.Doc.WriteP(Strings.EventCommands)
        f.Doc.WriteTips(TipProvider.GetTips)
        f.Doc.WriteTable("Properties", Macro.GetTipsFriendly(False))
        f.Doc.WriteTable("Commands", g.MainForm.CustomMainMenu.CommandManager.GetTips)
        f.Doc.WriteTable("Macros", Strings.MacrosHelp, Macro.GetTips())
        f.Show()
    End Sub

    Private Sub pgParameters_PropertyValueChanged(ByVal s As Object, ByVal e As PropertyValueChangedEventArgs) Handles pgParameters.PropertyValueChanged
        CommandParameters.Parameters.Clear()

        For Each i As DictionaryEntry In GridTypeDescriptor.Items
            CommandParameters.Parameters.Add(DirectCast(i.Value, GridProperty).Value)
        Next
    End Sub

    Private Sub EventCommandEditor_Shown() Handles Me.Shown
        PropertyGridHelp.MoveSplitter(pgParameters, 120)
    End Sub

    Private Sub EventCommandEditor_SizeChanged() Handles Me.SizeChanged
        PropertyGridHelp.MoveSplitter(pgParameters, 120)
    End Sub
End Class