Imports Stax
Imports Stax.UI
Imports Stax.AppFramework

Public Class EventCommandsEditor
    Inherits DialogBase

#Region " Designer "
    Friend WithEvents lbc As Stax.UI.ListBoxControl

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.lbc = New Stax.UI.ListBoxControl
        Me.SuspendLayout()
        '
        'lbc
        '
        Me.lbc.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lbc.Location = New System.Drawing.Point(9, 9)
        Me.lbc.Margin = New System.Windows.Forms.Padding(0)
        Me.lbc.Name = "lbc"
        Me.lbc.ShowUpDown = False
        Me.lbc.Size = New System.Drawing.Size(360, 220)
        Me.lbc.TabIndex = 1
        '
        'EventCommandsEditor
        '
        Me.ClientSize = New System.Drawing.Size(378, 281)
        Me.Controls.Add(Me.lbc)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Sizable
        Me.MinimumSize = New System.Drawing.Size(276, 215)
        Me.Name = "EventCommandsEditor"
        Me.Text = "Event Commands"
        Me.Controls.SetChildIndex(Me.lbc, 0)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public Sub New(ByVal actions As List(Of EventCommand))
        MyBase.New()
        InitializeComponent()

        lbc.ListBox.Items.AddRange(DirectCast(ObjectHelp.GetCopy(actions), _
            List(Of EventCommand)).ToArray)

        If lbc.ListBox.Items.Count > 0 Then
            lbc.ListBox.SelectedIndex = 0
        End If

        s.WindowPositions.Restore(Me, WindowPositions.Mode.Size)
    End Sub

    Public ReadOnly Property EventCommands() As List(Of EventCommand)
        Get
            Dim l As New List(Of EventCommand)

            For Each i As EventCommand In lbc.ListBox.Items
                l.Add(i)
            Next

            Return l
        End Get
    End Property

    Protected Overrides Sub OnFormClosed(ByVal e As FormClosedEventArgs)
        MyBase.OnFormClosed(e)
        s.WindowPositions.Save(Me)
    End Sub

    Private Sub EventCommandsEditor_HelpRequested() Handles Me.HelpRequested
        Dim f As New HelpForm
        f.Doc.WriteStart(Text)
        f.Doc.WriteP(Strings.EventCommands)
        f.Show()
    End Sub

    Private Sub lbc_ButtonClickAdd() Handles lbc.ButtonClickAdd
        Dim ec As New EventCommand

        Using f As New EventCommandEditor(ec)
            If f.ShowDialog = DialogResult.OK Then
                lbc.AddItem(ec)
            End If
        End Using
    End Sub

    Private Sub lbc_ButtonClickEdit() Handles lbc.ButtonClickEdit
        Using f As New EventCommandEditor(DirectCast(lbc.ListBox.SelectedItem, EventCommand))
            If f.ShowDialog = DialogResult.OK Then
                lbc.ListBox.UpdateSelection()
            End If
        End Using
    End Sub
End Class