Imports System.ComponentModel

Imports Stax.AppFramework
Imports Stax.UI
Imports Stax

Public Class MacroEditor
    Inherits DialogBase

#Region " Designer "

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents MacroEditorControl As StaxRip.MacroEditorControl

    Private components As System.ComponentModel.IContainer

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.MacroEditorControl = New StaxRip.MacroEditorControl
        Me.SuspendLayout()
        '
        'MacroEditorControl
        '
        Me.MacroEditorControl.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.MacroEditorControl.Location = New System.Drawing.Point(12, 12)
        Me.MacroEditorControl.Name = "MacroEditorControl"
        Me.MacroEditorControl.Size = New System.Drawing.Size(481, 280)
        Me.MacroEditorControl.TabIndex = 0
        '
        'MacroEditor
        '
        Me.ClientSize = New System.Drawing.Size(505, 337)
        Me.Controls.Add(Me.MacroEditorControl)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Sizable
        Me.MinimumSize = New System.Drawing.Size(354, 218)
        Me.Name = "MacroEditor"
        Me.ShowLine = False
        Me.Text = "Text"
        Me.Controls.SetChildIndex(Me.MacroEditorControl, 0)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private HelpText As String

    Public Sub New()
        MyBase.New()
        InitializeComponent()
    End Sub

    Public Sub SetCmdlDefaults()
        Text = "Command Line Editor"
        SetTypeTitleHelpId()
        HelpText = "Editor for command lines that may contain macros."
        MacroEditorControl.SetCmdlDefaults()
        Size = New Size(800, 250)
    End Sub

    Public Sub SetMacroDefaults()
        Text = "Macro String Editor"
        SetTypeTitleHelpId()
        HelpText = "Editor for strings that may contain macros."
        MacroEditorControl.SetMacroDefaults()
        Size = New Size(500, 400)
    End Sub

    Public Sub SetScriptDefaults()
        Text = "Script Editor"
        SetTypeTitleHelpId()
        HelpText = "Editor for scripts that may contain macros."
        MacroEditorControl.SetScriptDefaults()
        Size = New Size(600, 400)
    End Sub

    Private Sub UniversalEditor_HelpRequested(ByVal sender As Object, ByVal e As HelpEventArgs) Handles Me.HelpRequested
        Dim f As New HelpForm()
        f.Doc.WriteStart(Text)
        f.Doc.WriteP(HelpText)
        f.Doc.WriteTips(MacroEditorControl.TipProvider.GetTips)
        f.Doc.WriteTable("Macros", Strings.MacrosHelp, Macro.GetTips())
        f.Show()
    End Sub

    Public Sub AutoResize()
        Dim c = MacroEditorControl
        Dim s = TextRenderer.MeasureText(c.tbEdit.Text, c.tbEdit.Font)
        'TabPage and containing tbEdit return wrong size
        Width -= c.TabControl.Width - s.Width - 150
        Height -= c.TabControl.Height - s.Height - 150

        If Width < 500 Then
            Width = 500
        End If

        Dim b = Screen.PrimaryScreen.Bounds

        If Width > b.Width * 0.8 Then
            Width = CInt(b.Width * 0.8)
        End If
    End Sub
End Class