Imports Stax
Imports Stax.UI
Imports Stax.AppFramework
Imports System.ComponentModel

Public Class MacroListEditor
    Inherits ListEditor

    Public Sub New(ByVal items As IList)
        MyBase.New(items)
        HelpButton = True
        Text = "Custom Macros Editor"
        epg.PropertySort = PropertySort.NoSort
        lbc.ShowUpDown = False
        ItemType = GetType(Macro)
        Width += 50
    End Sub

    Private Sub MacroListEditor_HelpRequested(ByVal sender As Object, ByVal e As HelpEventArgs) Handles Me.HelpRequested
        Dim f As New HelpForm
        f.Doc.WriteStart(Text)
        f.Doc.WriteP("The custom macros editor allows to manage custom macros.")

        Dim l As New StringPairList

        For Each i As PropertyDescriptor In TypeDescriptor.GetProperties(GetType(Macro))
            If OK(i.Description) Then
                l.Add(i.DisplayName, i.Description)
            End If
        Next

        f.Doc.WriteTips(l)
        f.Show()
    End Sub
End Class

Public Class AviSynthScriptEditor
    Inherits MacroEditor

    Public Sub New(ByVal script As String)
        SetScriptDefaults()
        MacroEditorControl.Value = script
    End Sub
End Class