Imports Stax.UI
Imports Stax.AppFramework

Public Class OptionsForm
    Inherits DialogBase

#Region " Designer "

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    Friend WithEvents UserControlProxy As Stax.UI.ProxyControlContainer
    Friend WithEvents ToolStrip As Stax.UI.ExtendedToolStrip
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.UserControlProxy = New Stax.UI.ProxyControlContainer
        Me.ToolStrip = New Stax.UI.ExtendedToolStrip
        Me.SuspendLayout()
        '
        'UserControlProxy
        '
        Me.UserControlProxy.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.UserControlProxy.Location = New System.Drawing.Point(107, 9)
        Me.UserControlProxy.Name = "UserControlProxy"
        Me.UserControlProxy.Size = New System.Drawing.Size(406, 327)
        Me.UserControlProxy.TabIndex = 7
        '
        'ToolStrip
        '
        Me.ToolStrip.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.ToolStrip.AutoSize = False
        Me.ToolStrip.BackColor = System.Drawing.SystemColors.Window
        Me.ToolStrip.Dock = System.Windows.Forms.DockStyle.None
        Me.ToolStrip.Font = New System.Drawing.Font("Tahoma", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ToolStrip.GripStyle = System.Windows.Forms.ToolStripGripStyle.Hidden
        Me.ToolStrip.ImageScalingSize = New System.Drawing.Size(22, 22)
        Me.ToolStrip.LayoutStyle = System.Windows.Forms.ToolStripLayoutStyle.VerticalStackWithOverflow
        Me.ToolStrip.Location = New System.Drawing.Point(9, 9)
        Me.ToolStrip.Name = "ToolStrip"
        Me.ToolStrip.OverdrawLine = True
        Me.ToolStrip.Padding = New System.Windows.Forms.Padding(2, 1, 1, 1)
        Me.ToolStrip.RenderMode = System.Windows.Forms.ToolStripRenderMode.System
        Me.ToolStrip.ShowControlBorder = True
        Me.ToolStrip.ShowItemToolTips = False
        Me.ToolStrip.SingleAutoChecked = True
        Me.ToolStrip.Size = New System.Drawing.Size(94, 325)
        Me.ToolStrip.TabIndex = 6
        '
        'OptionsForm
        '
        Me.ClientSize = New System.Drawing.Size(525, 375)
        Me.Controls.Add(Me.UserControlProxy)
        Me.Controls.Add(Me.ToolStrip)
        Me.Name = "OptionsForm"
        Me.ShowLine = False
        Me.Text = "Project Options"
        Me.Controls.SetChildIndex(Me.ToolStrip, 0)
        Me.Controls.SetChildIndex(Me.UserControlProxy, 0)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Types As New Dictionary(Of ToolStripItem, Type)
    Private RecentControl As String = "RecentSettngsControl"
    Private ActiveDialogControl As DialogControl

    Public Sub New()
        MyBase.New()
        InitializeComponent()

        AddButton("Basic", GetType(OptionsBasicControl), My.Resources.Screwdriver22)
        AddButton("Automation", GetType(OptionsAutomationControl), My.Resources.CogwheelGrey22)
        AddButton("Preparation", GetType(OptionsPreparationControl), My.Resources.Checklist22)
        AddButton("Advanced", GetType(OptionsAdvancedControl), My.Resources.Config22)

        Dim index = s.Storage.GetInt("OptionsFormControlIndex", 0)

        If index >= ToolStrip.Items.Count Then
            index = 0
        End If

        ToolStrip.Items(index).PerformClick()
    End Sub

    Private Sub AddButton(ByVal text As String, ByVal t As Type, ByVal image As Image)
        Dim b As New ToolStripButton()

        b.Text = text
        b.Image = image
        b.TextImageRelation = TextImageRelation.ImageAboveText
        b.Padding = New Padding(2)

        ToolStrip.Items.Add(b)
        Types(b) = t
        AddHandler b.MouseDown, AddressOf ButtonMouseDown
    End Sub

    Private Sub OptionsForm_HelpRequested(ByVal sender As Object, ByVal hlpevent As HelpEventArgs) Handles Me.HelpRequested
        ActiveDialogControl.ShowHelp()
    End Sub

    Private Sub ToolStrip_ItemClicked(ByVal sender As Object, ByVal e As ToolStripItemClickedEventArgs) Handles ToolStrip.ItemClicked
        ActiveDialogControl = DirectCast(UserControlProxy.ShowControl(Types(e.ClickedItem), True), DialogControl)
        ActiveDialogControl.Text = e.ClickedItem.Text
        s.Storage.SetInt("OptionsFormControlIndex", ToolStrip.Items.IndexOf(e.ClickedItem))
    End Sub

    Private Sub ButtonMouseDown(ByVal sender As Object, ByVal e As MouseEventArgs)
        DirectCast(sender, ToolStripButton).PerformClick()
    End Sub

    Public Sub ShowAdvancedNode(ByVal value As String)
        Dim a = From i In ToolStrip.Items Where i.ToString = "Advanced"
        DirectCast(a(0), ToolStripButton).PerformClick()
        Dim c = DirectCast(ActiveDialogControl, OptionsAdvancedControl)
        c.stv.ExpandNode(value)
    End Sub
End Class