Imports System.ComponentModel
Imports System.Text.RegularExpressions
Imports System.Drawing.Design
Imports System.Threading

Imports Stax
Imports Stax.DynamicObject
Imports Stax.UI
Imports Stax.ComponentModel
Imports Stax.AppFramework

Public Class PreviewForm
    Inherits Form

#Region " Designer "
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    Friend WithEvents pVideo As System.Windows.Forms.Panel
    Friend WithEvents pTrack As System.Windows.Forms.Panel
    Private WithEvents bDeleteRange As System.Windows.Forms.Button
    Private WithEvents bForward1 As System.Windows.Forms.Button
    Private WithEvents bRangeStart As System.Windows.Forms.Button
    Private WithEvents bRangeEnd As System.Windows.Forms.Button
    Private WithEvents bForward10 As System.Windows.Forms.Button
    Private WithEvents bBackward10 As System.Windows.Forms.Button
    Private WithEvents bExtras As System.Windows.Forms.Button
    Private WithEvents bForward100 As System.Windows.Forms.Button
    Private WithEvents bBackward100 As System.Windows.Forms.Button
    Private WithEvents bBackward1 As System.Windows.Forms.Button
    Friend WithEvents il2212 As System.Windows.Forms.ImageList
    Friend WithEvents cmsMain As System.Windows.Forms.ContextMenuStrip
    Friend WithEvents ActionListInitLabel1 As Stax.UI.Design.ActionListInitLabel
    Friend WithEvents ToolTip As System.Windows.Forms.ToolTip

    '<System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(PreviewForm))
        Me.bDeleteRange = New System.Windows.Forms.Button
        Me.il2212 = New System.Windows.Forms.ImageList(Me.components)
        Me.bForward1 = New System.Windows.Forms.Button
        Me.bBackward1 = New System.Windows.Forms.Button
        Me.bRangeStart = New System.Windows.Forms.Button
        Me.bRangeEnd = New System.Windows.Forms.Button
        Me.bForward10 = New System.Windows.Forms.Button
        Me.bBackward10 = New System.Windows.Forms.Button
        Me.bExtras = New System.Windows.Forms.Button
        Me.bForward100 = New System.Windows.Forms.Button
        Me.bBackward100 = New System.Windows.Forms.Button
        Me.pVideo = New System.Windows.Forms.Panel
        Me.cmsMain = New System.Windows.Forms.ContextMenuStrip(Me.components)
        Me.pTrack = New System.Windows.Forms.Panel
        Me.ToolTip = New System.Windows.Forms.ToolTip(Me.components)
        Me.ActionListInitLabel1 = New Stax.UI.Design.ActionListInitLabel
        Me.pVideo.SuspendLayout()
        Me.SuspendLayout()
        '
        'bDeleteRange
        '
        Me.bDeleteRange.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.bDeleteRange.BackColor = System.Drawing.Color.White
        Me.bDeleteRange.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.bDeleteRange.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.bDeleteRange.ImageIndex = 5
        Me.bDeleteRange.ImageList = Me.il2212
        Me.bDeleteRange.Location = New System.Drawing.Point(360, 280)
        Me.bDeleteRange.Name = "bDeleteRange"
        Me.bDeleteRange.Size = New System.Drawing.Size(32, 24)
        Me.bDeleteRange.TabIndex = 47
        Me.bDeleteRange.TabStop = False
        Me.ToolTip.SetToolTip(Me.bDeleteRange, "Deletes the cut selection that encloses the current position.")
        Me.bDeleteRange.UseVisualStyleBackColor = False
        '
        'il2212
        '
        Me.il2212.ImageStream = CType(resources.GetObject("il2212.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.il2212.TransparentColor = System.Drawing.Color.Transparent
        Me.il2212.Images.SetKeyName(0, "")
        Me.il2212.Images.SetKeyName(1, "")
        Me.il2212.Images.SetKeyName(2, "")
        Me.il2212.Images.SetKeyName(3, "")
        Me.il2212.Images.SetKeyName(4, "")
        Me.il2212.Images.SetKeyName(5, "")
        Me.il2212.Images.SetKeyName(6, "")
        Me.il2212.Images.SetKeyName(7, "")
        Me.il2212.Images.SetKeyName(8, "")
        Me.il2212.Images.SetKeyName(9, "")
        '
        'bForward1
        '
        Me.bForward1.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.bForward1.BackColor = System.Drawing.Color.White
        Me.bForward1.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.bForward1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.bForward1.ImageIndex = 7
        Me.bForward1.ImageList = Me.il2212
        Me.bForward1.Location = New System.Drawing.Point(240, 280)
        Me.bForward1.Name = "bForward1"
        Me.bForward1.Size = New System.Drawing.Size(32, 24)
        Me.bForward1.TabIndex = 46
        Me.bForward1.TabStop = False
        Me.ToolTip.SetToolTip(Me.bForward1, "Forward 1 Frames")
        Me.bForward1.UseVisualStyleBackColor = False
        '
        'bBackward1
        '
        Me.bBackward1.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.bBackward1.BackColor = System.Drawing.Color.White
        Me.bBackward1.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.bBackward1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.bBackward1.ImageIndex = 0
        Me.bBackward1.ImageList = Me.il2212
        Me.bBackward1.Location = New System.Drawing.Point(120, 280)
        Me.bBackward1.Name = "bBackward1"
        Me.bBackward1.Size = New System.Drawing.Size(32, 24)
        Me.bBackward1.TabIndex = 45
        Me.bBackward1.TabStop = False
        Me.ToolTip.SetToolTip(Me.bBackward1, "Backward 1 Frame")
        Me.bBackward1.UseVisualStyleBackColor = False
        '
        'bRangeStart
        '
        Me.bRangeStart.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.bRangeStart.BackColor = System.Drawing.Color.White
        Me.bRangeStart.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.bRangeStart.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.bRangeStart.ImageIndex = 4
        Me.bRangeStart.ImageList = Me.il2212
        Me.bRangeStart.Location = New System.Drawing.Point(160, 280)
        Me.bRangeStart.Name = "bRangeStart"
        Me.bRangeStart.Size = New System.Drawing.Size(32, 24)
        Me.bRangeStart.TabIndex = 44
        Me.bRangeStart.TabStop = False
        Me.ToolTip.SetToolTip(Me.bRangeStart, "Sets a start cut point. Please press F1 for help about cutting")
        Me.bRangeStart.UseVisualStyleBackColor = False
        '
        'bRangeEnd
        '
        Me.bRangeEnd.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.bRangeEnd.BackColor = System.Drawing.Color.White
        Me.bRangeEnd.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.bRangeEnd.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.bRangeEnd.ImageIndex = 3
        Me.bRangeEnd.ImageList = Me.il2212
        Me.bRangeEnd.Location = New System.Drawing.Point(200, 280)
        Me.bRangeEnd.Name = "bRangeEnd"
        Me.bRangeEnd.Size = New System.Drawing.Size(32, 24)
        Me.bRangeEnd.TabIndex = 43
        Me.bRangeEnd.TabStop = False
        Me.ToolTip.SetToolTip(Me.bRangeEnd, "Sets a end cut point. Please press F1 for help about cutting")
        Me.bRangeEnd.UseVisualStyleBackColor = False
        '
        'bForward10
        '
        Me.bForward10.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.bForward10.BackColor = System.Drawing.Color.White
        Me.bForward10.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.bForward10.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.bForward10.ImageIndex = 8
        Me.bForward10.ImageList = Me.il2212
        Me.bForward10.Location = New System.Drawing.Point(280, 280)
        Me.bForward10.Name = "bForward10"
        Me.bForward10.Size = New System.Drawing.Size(32, 24)
        Me.bForward10.TabIndex = 42
        Me.bForward10.TabStop = False
        Me.ToolTip.SetToolTip(Me.bForward10, "Forward 10 Frames")
        Me.bForward10.UseVisualStyleBackColor = False
        '
        'bBackward10
        '
        Me.bBackward10.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.bBackward10.BackColor = System.Drawing.Color.White
        Me.bBackward10.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.bBackward10.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.bBackward10.ImageIndex = 1
        Me.bBackward10.ImageList = Me.il2212
        Me.bBackward10.Location = New System.Drawing.Point(80, 280)
        Me.bBackward10.Name = "bBackward10"
        Me.bBackward10.Size = New System.Drawing.Size(32, 24)
        Me.bBackward10.TabIndex = 41
        Me.bBackward10.TabStop = False
        Me.ToolTip.SetToolTip(Me.bBackward10, "Backward 10 Frames")
        Me.bBackward10.UseVisualStyleBackColor = False
        '
        'bExtras
        '
        Me.bExtras.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.bExtras.BackColor = System.Drawing.Color.White
        Me.bExtras.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.bExtras.Font = New System.Drawing.Font("Microsoft Sans Serif", 15.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.bExtras.ForeColor = System.Drawing.SystemColors.ControlText
        Me.bExtras.ImageList = Me.il2212
        Me.bExtras.Location = New System.Drawing.Point(400, 280)
        Me.bExtras.Name = "bExtras"
        Me.bExtras.Size = New System.Drawing.Size(32, 24)
        Me.bExtras.TabIndex = 50
        Me.bExtras.TabStop = False
        Me.ToolTip.SetToolTip(Me.bExtras, "Shows the menu")
        Me.bExtras.UseVisualStyleBackColor = False
        '
        'bForward100
        '
        Me.bForward100.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.bForward100.BackColor = System.Drawing.Color.White
        Me.bForward100.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.bForward100.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.bForward100.ForeColor = System.Drawing.SystemColors.ControlText
        Me.bForward100.ImageIndex = 9
        Me.bForward100.ImageList = Me.il2212
        Me.bForward100.Location = New System.Drawing.Point(320, 280)
        Me.bForward100.Name = "bForward100"
        Me.bForward100.Size = New System.Drawing.Size(32, 24)
        Me.bForward100.TabIndex = 49
        Me.bForward100.TabStop = False
        Me.ToolTip.SetToolTip(Me.bForward100, "Forward 100 Frames")
        Me.bForward100.UseVisualStyleBackColor = False
        '
        'bBackward100
        '
        Me.bBackward100.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.bBackward100.BackColor = System.Drawing.Color.White
        Me.bBackward100.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.bBackward100.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.bBackward100.ForeColor = System.Drawing.SystemColors.ControlText
        Me.bBackward100.ImageIndex = 2
        Me.bBackward100.ImageList = Me.il2212
        Me.bBackward100.Location = New System.Drawing.Point(40, 280)
        Me.bBackward100.Name = "bBackward100"
        Me.bBackward100.Size = New System.Drawing.Size(32, 24)
        Me.bBackward100.TabIndex = 48
        Me.bBackward100.TabStop = False
        Me.ToolTip.SetToolTip(Me.bBackward100, "Backward 100 Frames")
        Me.bBackward100.UseVisualStyleBackColor = False
        '
        'pVideo
        '
        Me.pVideo.ContextMenuStrip = Me.cmsMain
        Me.pVideo.Controls.Add(Me.pTrack)
        Me.pVideo.Controls.Add(Me.bRangeEnd)
        Me.pVideo.Controls.Add(Me.bRangeStart)
        Me.pVideo.Controls.Add(Me.bBackward1)
        Me.pVideo.Controls.Add(Me.bForward1)
        Me.pVideo.Controls.Add(Me.bDeleteRange)
        Me.pVideo.Controls.Add(Me.bBackward100)
        Me.pVideo.Controls.Add(Me.bForward100)
        Me.pVideo.Controls.Add(Me.bExtras)
        Me.pVideo.Controls.Add(Me.bBackward10)
        Me.pVideo.Controls.Add(Me.bForward10)
        Me.pVideo.Location = New System.Drawing.Point(16, 16)
        Me.pVideo.Name = "pVideo"
        Me.pVideo.Size = New System.Drawing.Size(472, 312)
        Me.pVideo.TabIndex = 50
        '
        'cmsMain
        '
        Me.cmsMain.Name = "cmsMain"
        Me.cmsMain.Size = New System.Drawing.Size(61, 4)
        '
        'pTrack
        '
        Me.pTrack.Anchor = CType(((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.pTrack.BackColor = System.Drawing.SystemColors.Control
        Me.pTrack.Cursor = System.Windows.Forms.Cursors.SizeNS
        Me.pTrack.Location = New System.Drawing.Point(16, 256)
        Me.pTrack.Name = "pTrack"
        Me.pTrack.Size = New System.Drawing.Size(440, 12)
        Me.pTrack.TabIndex = 51
        '
        'ToolTip
        '
        Me.ToolTip.AutoPopDelay = 5000
        Me.ToolTip.BackColor = System.Drawing.Color.White
        Me.ToolTip.InitialDelay = 100
        Me.ToolTip.ReshowDelay = 100
        '
        'ActionListInitLabel1
        '
        Me.ActionListInitLabel1.Dummy = False
        Me.ActionListInitLabel1.Location = New System.Drawing.Point(-300, -300)
        Me.ActionListInitLabel1.Size = New System.Drawing.Size(100, 23)
        '
        'PreviewForm
        '
        Me.BackColor = System.Drawing.Color.Black
        Me.ClientSize = New System.Drawing.Size(506, 352)
        Me.Controls.Add(Me.pVideo)
        Me.Controls.Add(Me.ActionListInitLabel1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.HelpButton = True
        Me.KeyPreview = True
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "PreviewForm"
        Me.Text = "Preview"
        Me.pVideo.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public AVI As New AVIFile
    Public RangeStart As Integer = -1

    Private InfoAviSynthDocument As AviSynthDocument
    Private AviSynthDocument As AviSynthDocument
    Private ShowInfo As Boolean
    Private SizeFactor As Double = 1
    Private TargetFrames As Integer
    Private WithEvents GenericMenu As CustomMenu
    Private CommandManager As New CommandManager

    Private Const TrackBarBorder As Integer = 1
    Private Const TrackBarGap As Integer = 1
    Private Const TrackBarPosition As Integer = 4
    Private Shared Instances As New List(Of PreviewForm)

    Public Sub New(ByVal aviSynthDocument As AviSynthDocument)
        MyBase.New()
        InitializeComponent()

        CommandManager.AddCommandsFromObject(Me)
        CommandManager.AddCommandsFromObject(g.DefaultCommands)

        GenericMenu = New CustomMenu(AddressOf GetDefaultMenu, _
            s.CustomMenuPreview, CommandManager, cmsMain)

        GenericMenu.AddKeyDownHandler(Me)
        GenericMenu.BuildMenu()

        Instances.Add(Me)

        Me.AviSynthDocument = aviSynthDocument

        RefreshScript()

        If WindowState <> s.WindowStatePreview Then
            SwitchWindowState()
        End If

        s.WindowPositions.RestorePosition(Me)
        ShowButtons(Not s.HidePreviewButtons)
        Icon = My.Resources.MainIcon
    End Sub

    Public Sub RefreshScript()
        TargetFrames = p.TargetAVSDoc.GetFrames

        If ShowInfo Then
            If InfoAviSynthDocument Is Nothing Then
                InfoAviSynthDocument = New AviSynthDocument
                InfoAviSynthDocument.Path = g.TempDir + p.Name + "_Info.avs"
            End If

            InfoAviSynthDocument.Filters.Clear()

            For Each i As AviSynthFilter In AviSynthDocument.Filters
                InfoAviSynthDocument.Filters.Add(i.GetCopy)
            Next

            InfoAviSynthDocument.Filters.Add(New AviSynthFilter("Info", "Info", p.PreviewScript.Value, True))
            InfoAviSynthDocument.Synchronize()

            AVI.Open(InfoAviSynthDocument.Path, pVideo)
        Else
            AVI.Open(AviSynthDocument.Path, pVideo)
        End If

        If WindowState = FormWindowState.Normal Then
            Normal()
        Else
            Full()
        End If

        If s.LastPosition < (AVI.FrameCount - 1) Then
            AVI.Position = s.LastPosition
        End If

        AVI.Draw()

        AfterPositionChanged()
    End Sub

    <Command("Perform|Toggle Aspect Ratio", "Toggles between target display aspect ratio and target storage aspect ratio.")> _
    Private Sub ToggleAspectRatio()
        s.PreviewShowsDAR = Not s.PreviewShowsDAR

        If WindowState = FormWindowState.Normal Then
            Normal()
        Else
            Full()
        End If
    End Sub

    Private Sub Full()
        pTrack.Visible = False

        FormBorderStyle = Windows.Forms.FormBorderStyle.None
        WindowState = FormWindowState.Maximized

        Dim ratio As Double

        If s.PreviewShowsDAR AndAlso Calc.IsARSignalingRequired Then
            ratio = Calc.GetTargetDAR
        Else
            ratio = AVI.FrameSize.Width / AVI.FrameSize.Height
        End If

        Dim b = Screen.PrimaryScreen.Bounds

        pVideo.Dock = DockStyle.None

        If ratio > 1.333 Then
            Dim h = CInt(b.Width / ratio)
            pVideo.Left = 0
            pVideo.Top = CInt((b.Height - h) / 2)
            pVideo.Width = b.Width
            pVideo.Height = h
        Else
            Dim w = CInt(b.Height * ratio)
            pVideo.Left = CInt((b.Width - w) / 2)
            pVideo.Top = 0
            pVideo.Width = w
            pVideo.Height = b.Height
        End If

        pTrack.Visible = True
    End Sub

    Private Sub Normal()
        WindowState = FormWindowState.Normal
        FormBorderStyle = Windows.Forms.FormBorderStyle.FixedDialog
        pVideo.Dock = DockStyle.Fill

        Dim w = AVI.FrameSize.Width, h = AVI.FrameSize.Height
        Dim newSize As Size
        Dim b = Screen.PrimaryScreen.Bounds

        If s.PreviewShowsDAR AndAlso Calc.IsARSignalingRequired Then
            newSize = New Size(CInt(h * SizeFactor * Calc.GetTargetDAR), CInt(h * SizeFactor))
        Else
            newSize = New Size(CInt(w * SizeFactor), CInt(h * SizeFactor))
        End If

        If newSize.Width > b.Width OrElse newSize.Height > b.Height Then
            newSize.Width \= 2
            newSize.Height \= 2
        End If

        ClientSize = newSize
    End Sub

    <Command("Perform|Switch Window State", "Switches the window state between full and normal.")> _
    Public Sub SwitchWindowState()
        If WindowState = FormWindowState.Normal Then
            Full()
        Else
            Normal()
        End If

        AfterPositionChanged()
    End Sub

    Sub ShowButtons(ByVal vis As Boolean)
        bForward1.Visible = vis
        bBackward1.Visible = vis
        bRangeStart.Visible = vis
        bRangeEnd.Visible = vis
        bDeleteRange.Visible = vis
        bForward10.Visible = vis
        bBackward10.Visible = vis
        bForward100.Visible = vis
        bBackward100.Visible = vis
        bExtras.Visible = vis
    End Sub

    Private Sub bForward1_Click() Handles bForward1.Click
        For Each i As PreviewForm In Instances
            SetRelativePos(1)
        Next
    End Sub

    Private Sub bBackward1_Click() Handles bBackward1.Click
        For Each i As PreviewForm In Instances
            SetRelativePos(-1)
        Next
    End Sub

    Private Sub bRangeStart_Click() Handles bRangeStart.Click
        For Each i As PreviewForm In Instances
            SetRangeStart()
        Next
    End Sub

    Private Sub bRangeEnd_Click() Handles bRangeEnd.Click
        For Each i As PreviewForm In Instances
            SetRangeEnd()
        Next
    End Sub

    Private Sub bBackward10_Click() Handles bBackward10.Click
        For Each i As PreviewForm In Instances
            SetRelativePos(-10)
        Next
    End Sub

    Private Sub bForward10_Click() Handles bForward10.Click
        For Each i As PreviewForm In Instances
            SetRelativePos(10)
        Next
    End Sub

    Private Sub bDeleteRange_Click() Handles bDeleteRange.Click
        For Each i As PreviewForm In Instances
            DeleteRange()
        Next
    End Sub

    Private Sub bBackward100_Click() Handles bBackward100.Click
        For Each i As PreviewForm In Instances
            i.SetRelativePos(-100)
        Next
    End Sub

    Private Sub bForward100_Click() Handles bForward100.Click
        For Each i As PreviewForm In Instances
            SetRelativePos(100)
        Next
    End Sub

    Private Sub PreviewForm_GiveFeedback(ByVal sender As Object, ByVal e As System.Windows.Forms.GiveFeedbackEventArgs) Handles Me.GiveFeedback

    End Sub

    Private Sub PreviewForm_Shown() Handles Me.Shown
        If s.ShowInitialHelp.Value AndAlso Not s.StringList.Contains(Me.GetType.FullName) Then
            OpenHelp()
            s.StringList.Add(Me.GetType.FullName)
        End If
    End Sub

    Private Sub Wheel(ByVal sender As Object, ByVal e As MouseEventArgs) Handles MyBase.MouseWheel
        If e.Delta > 0 Then
            If Control.ModifierKeys = Keys.Alt Then
                AVI.Position += 1000
            ElseIf Control.ModifierKeys = Keys.Shift Then
                AVI.Position += 100
            ElseIf Control.ModifierKeys = Keys.Control Then
                AVI.Position += 10
            Else
                AVI.Position += 1
            End If
        Else
            If Control.ModifierKeys = Keys.Alt Then
                AVI.Position -= 1000
            ElseIf Control.ModifierKeys = Keys.Shift Then
                AVI.Position -= 100
            ElseIf Control.ModifierKeys = Keys.Control Then
                AVI.Position -= 10
            Else
                AVI.Position -= 1
            End If
        End If

        AVI.Draw()
        DrawTrack()
    End Sub

    Public Sub DrawTrack()
        Dim g As Graphics = pTrack.CreateGraphics()
        g.FillRectangle(Brushes.White, pTrack.ClientRectangle)

        Dim trackWidth As Integer = pTrack.Height - TrackBarBorder * 2 - TrackBarGap * 2

        Dim borderPen As Pen = New Pen(Color.Black, TrackBarBorder)
        borderPen.Alignment = Drawing2D.PenAlignment.Inset
        g.DrawRectangle(borderPen, 0, 0, pTrack.Width - 1, pTrack.Height - 1)
        borderPen.Dispose()

        Dim rangePen As Pen = New Pen(Color.Green, trackWidth)

        For Each i As Range In p.Ranges
            g.DrawLine(rangePen, GetDrawPos(i.Start) - TrackBarPosition \ 2, _
                pTrack.Height \ 2, GetDrawPos(i.End) + TrackBarPosition \ 2, pTrack.Height \ 2)
        Next

        rangePen.Dispose()

        Dim rangeSetPen As Pen = New Pen(Color.Yellow, trackWidth)

        If RangeStart > -1 AndAlso RangeStart <= AVI.Position Then
            g.DrawLine(rangeSetPen, GetDrawPos(RangeStart) - TrackBarPosition \ 2, _
                pTrack.Height \ 2, GetDrawPos(AVI.Position) + _
                TrackBarPosition \ 2, pTrack.Height \ 2)
        End If

        rangeSetPen.Dispose()
        Dim posPen As Pen

        If RangeStart > -1 Then
            posPen = New Pen(Color.Yellow, trackWidth)
        Else
            posPen = New Pen(Color.Blue, trackWidth)
        End If

        Dim pos As Integer = GetDrawPos(AVI.Position)
        g.DrawLine(posPen, pos - TrackBarPosition \ 2, pTrack.Height \ 2, pos + TrackBarPosition \ 2, pTrack.Height \ 2)
        posPen.Dispose()

        g.Dispose()
    End Sub

    Private Function GetDrawPos(ByVal frame As Integer) As Integer
        Dim values = TrackBarBorder * 2 + TrackBarGap * 2 + TrackBarPosition
        Dim width = CInt(((pTrack.Width - values) / TargetFrames) * frame)
        Return width + values \ 2
    End Function

    Private Sub pTrack_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs) Handles pTrack.MouseMove
        If e.Button = Windows.Forms.MouseButtons.Left Then
            HandleMouseOntrackBar()
        End If
    End Sub

    Private Sub pTrack_MouseDown(ByVal sender As Object, ByVal e As MouseEventArgs) Handles pTrack.MouseDown
        HandleMouseOntrackBar()
    End Sub

    Private Sub HandleMouseOntrackBar()
        Dim pos As Integer = CInt((TargetFrames / pTrack.Width) * _
            pTrack.PointToClient(Control.MousePosition).X)

        Dim remainder As Integer = pos Mod 4

        If remainder <> 0 Then
            pos -= remainder
        End If

        For Each i As PreviewForm In Instances
            i.SetAbsolutePos(pos)
        Next
    End Sub

    Private Sub pTrack_Paint(ByVal sender As Object, ByVal e As PaintEventArgs) Handles pTrack.Paint
        DrawTrack()
    End Sub

    Private Sub bExtras_Click() Handles bExtras.Click
        cmsMain.Show(bExtras, New Point(1, bExtras.Height))
    End Sub

    <Command("Parameter|Absolute Position", "Jumps to a given frame.")> _
    Public Sub SetAbsolutePos(<DisplayInfo("Position")> ByVal pos As Integer)
        AVI.Position = pos
        AVI.Draw()
        AfterPositionChanged()
    End Sub

    Private Sub AfterPositionChanged()
        s.LastPosition = AVI.Position
        DrawTrack()
    End Sub

    <Command("Dialog|Go To Time", "Dialog to jump to a specific time.")> _
    Public Sub GoToTime()
        Dim milli As Integer = CInt((AVI.Position / AVI.FrameRate) * 1000)
        Dim ts As New TimeSpan(0, 0, 0, 0, milli)

        Dim value As String = ts.Hours.ToString + ":" + ts.Minutes.ToString("00") + ":" + _
            ts.Seconds.ToString("00") + "." + ts.Milliseconds.ToString("000")

        value = InputBox.Show("Time:", "Go To Time", value)

        If Not value Is Nothing Then
            Try
                Dim m As Match = Regex.Match(value, "^(\d+):(\d+):(\d+)\.(\d+)$")
                ts = New TimeSpan(0, CInt(m.Groups(1).Value), CInt(m.Groups(2).Value), CInt(m.Groups(3).Value), CInt(m.Groups(4).Value))
                AVI.Position = CInt((ts.TotalMilliseconds / 1000) * AVI.FrameRate)
                AVI.Draw()
                AfterPositionChanged()
            Catch
            End Try
        End If
    End Sub

    <Command("Dialog|Go To Frame", "Dialog to jump to a specific frame.")> _
    Public Sub GoToFrame()
        Dim value As String = InputBox.Show("Frame:", "Go To Frame", AVI.Position.ToString)
        Dim pos As Integer

        If Integer.TryParse(value, pos) Then
            AVI.Position = pos
            AVI.Draw()
            AfterPositionChanged()
        End If
    End Sub

    <Command("Parameter|Relative Position", "Jumps a given frame count.")> _
    Public Sub SetRelativePos(<DisplayInfo("Position"), _
        Description("Frames to jump, negative values jump backward.")> _
        ByVal pos As Integer)

        AVI.Position += pos
        AVI.Draw()
        AfterPositionChanged()
    End Sub

    <Command("Dialog|Menu Editor", "Opens the menu editor.")> _
    Public Sub OpenMenuEditor()
        s.CustomMenuPreview = GenericMenu.Edit()
        g.MainForm.SaveSettings()
    End Sub

    <Command("Dialog|Help", "Opens the help.")> _
    Public Sub OpenHelp()
        Dim f As New HelpForm
        f.Doc.WriteStart(Text)
        f.Doc.WriteP("The preview dialog allows to preview and cut the video. Cutting can be achieved by selecting the sections that should be kept. Selected sections appear green in the trackbar. Everything not green will be trimmed off. It's possible to open more than one instance of the preview for filter comparisons.")
        f.Doc.WriteTips(GenericMenu.GetTips)
        f.Doc.WriteTable("Shortcut Keys", GenericMenu.GetKeys, False)
        f.Show()
    End Sub

    <Command("Perform|Set Cut Start", "Sets the start cut position.")> _
    Public Sub SetRangeStart()
        If Not IsValidCutPosition() Then
            Msg.Show("The current possition is already selected.", MsgIcon.Warning)
            Exit Sub
        End If

        RangeStart = AVI.Position
        AfterPositionChanged()
    End Sub

    <Command("Perform|Set Cut End", "Sets the end cut position.")> _
    Public Sub SetRangeEnd()
        If Not IsValidCutPosition() Then
            Msg.Show("The current possition is already selected.", MsgIcon.Warning)
            Exit Sub
        End If

        If RangeStart > -1 Then
            p.Ranges.Add(New Range(RangeStart, AVI.Position))
            p.Ranges.Sort()
            RangeStart = -1
            AfterPositionChanged()
        End If
    End Sub

    <Command("Perform|Clear Cuts", "Clears all cuts.")> _
    Public Sub ClearAllRanges()
        p.Ranges.Clear()
        AfterPositionChanged()
    End Sub

    <Command("Perform|Delete Current Range", "Deletes the range that encloses the current position.")> _
    Public Sub DeleteRange()
        For Each i As Range In p.Ranges.ToArray
            If AVI.Position >= i.Start AndAlso AVI.Position <= i.End Then
                p.Ranges.Remove(i)
            End If
        Next

        AfterPositionChanged()
    End Sub

    <Command("Perform|Show Hide Buttons", "Shows or hides the buttons.")> _
    Public Sub ShowHideButtons()
        s.HidePreviewButtons = Not s.HidePreviewButtons
        ShowButtons(Not s.HidePreviewButtons)
        AfterPositionChanged()
    End Sub

    <Command("Perform|Show Hide Trackbar", "Shows or hides the trackbar.")> _
    Public Sub ShowHideTrackbar()
        pTrack.Visible = Not pTrack.Visible
        AfterPositionChanged()
    End Sub

    <Command("Parameter|Change Size", "Changes the size.")> _
    Public Sub Zoom(<DisplayInfo("Factor")> ByVal factor As Single)
        SizeFactor += factor
        Normal()
        AfterPositionChanged()
    End Sub

    <Command("Perform|Show Hide Infos", "Shows or hides video parameters.")> _
    Public Sub ShowHideInfos()
        ShowInfo = Not ShowInfo
        RefreshScript()
        AfterPositionChanged()
    End Sub

    <Command("Perform|Reload Script", "Reloads the script.")> _
    Public Sub Reload()
        RefreshScript()
        AfterPositionChanged()
    End Sub

    <Command("Perform|Exit", "Closes the dialog.")> _
    Public Sub CloseDialog()
        Close()
    End Sub

    Private Sub pVideo_DoubleClick() Handles pVideo.DoubleClick
        SwitchWindowState()
    End Sub

    Public MovePoint As Point

    Private Sub pVideo_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs) Handles pVideo.MouseMove
        If e.Button = MouseButtons.Left Then
            Dim p = MousePosition

            p.X = p.X - MovePoint.X
            p.Y = p.Y - MovePoint.Y

            Location = p
        End If
    End Sub

    Private Sub pVideo_MouseDown(ByVal sender As Object, ByVal e As MouseEventArgs) Handles pVideo.MouseDown
        MovePoint.X = MousePosition.X - Location.X
        MovePoint.Y = MousePosition.Y - Location.Y
    End Sub

    <Command("Perform|Previous Cut Point", "Jumps to the previous cut point.")> _
    Public Sub JumpToThePreviousRangePos()
        Dim list As New List(Of Object)

        For Each i As Range In p.Ranges
            list.Add(i.Start)
            list.Add(i.End)
        Next

        list.Add(AVI.Position - 1)

        list.Sort()

        Dim index As Integer = list.IndexOf(AVI.Position - 1) - 1

        If index >= 0 AndAlso index < list.Count Then
            AVI.Position = CInt(list(index))
            AVI.Draw()
            AfterPositionChanged()
        End If
    End Sub

    <Command("Perform|Next Cut Point", "Jumps to the next cut point.")> _
    Public Sub JumpToTheNextRangePos()
        Dim list As New List(Of Object)

        For Each i As Range In p.Ranges
            list.Add(i.Start)
            list.Add(i.End)
        Next

        list.Add(AVI.Position + 1)
        list.Sort()

        Dim index As Integer = list.IndexOf(AVI.Position + 1) + 1

        If index >= 0 AndAlso index < list.Count Then
            AVI.Position = CInt(list(index))
            AVI.Draw()
            AfterPositionChanged()
        End If
    End Sub

    Public Shared Function GetDefaultMenu() As CustomMenuItem
        Dim ret As CustomMenuItem = New CustomMenuItem("Root")

        ret.Add("Navigation/Go To Start", "SetAbsolutePos", Keys.Control Or Keys.Left, 0)
        ret.Add("Navigation/Go To End", "SetAbsolutePos", Keys.Control Or Keys.Right, 1000000000)
        ret.Add("Navigation/Go To Frame...", "GoToFrame")
        ret.Add("Navigation/Go To Time...", "GoToTime")
        ret.Add("Navigation/-")
        ret.Add("Navigation/Go To Previous Cut Point", "JumpToThePreviousRangePos", Keys.Control Or Keys.Up)
        ret.Add("Navigation/Go To Next Cut Point", "JumpToTheNextRangePos", Keys.Control Or Keys.Down)
        ret.Add("Navigation/-")
        ret.Add("Navigation/Backward 1 Frame", "SetRelativePos", Keys.Left, -1)
        ret.Add("Navigation/Backward 10 Frames", "SetRelativePos", Keys.Up, -10)
        ret.Add("Navigation/Backward 100 Frames", "SetRelativePos", Keys.Prior, -100)
        ret.Add("Navigation/Backward 1000 Frames", "SetRelativePos", Keys.Subtract, -1000)
        ret.Add("Navigation/-")
        ret.Add("Navigation/Forward 1000 Frames", "SetRelativePos", Keys.Add, 1000)
        ret.Add("Navigation/Forward 100 Frames", "SetRelativePos", Keys.Next, 100)
        ret.Add("Navigation/Forward 10 Frames", "SetRelativePos", Keys.Down, 10)
        ret.Add("Navigation/Forward 1 Frames", "SetRelativePos", Keys.Right, 1)
        ret.Add("Cut/Begin Selection", "SetRangeStart", Keys.Home)
        ret.Add("Cut/End Selection", "SetRangeEnd", Keys.End)
        ret.Add("Cut/Delete Selection", "DeleteRange", Keys.Delete)
        ret.Add("Cut/Delete All Selections", "ClearAllRanges", Keys.Control Or Keys.Delete)
        ret.Add("Tools/Info", "ShowHideInfos", Keys.I)
        ret.Add("Tools/Reload", "Reload", Keys.R)
        ret.Add("Tools/External Preview", "ExecuteCmdl", Keys.E, GetExternalPreviewCmdl)
        ret.Add("Tools/Copy Frame Number", "CopyToClipboard", "%pos_frame%")
        ret.Add("Tools/Set Credits", "AddEncoderParameters", Keys.C, "--zones %pos_frame%,%eval:%source_frames%-1%,q=40")
        ret.Add("Dialog/Fullscreen", "SwitchWindowState", Keys.Enter)
        ret.Add("Dialog/Toggle Aspect Ratio", "ToggleAspectRatio", Keys.A)
        ret.Add("Dialog/-")
        ret.Add("Dialog/Zoom In", "Zoom", Keys.OemMinus, -0.25F)
        ret.Add("Dialog/Zoom Out", "Zoom", Keys.Oemplus, 0.25F)
        ret.Add("Dialog/-")
        ret.Add(New String() {"Dialog", "Show/Hide Buttons"}, "ShowHideButtons", Keys.B)
        ret.Add(New String() {"Dialog", "Show/Hide Trackbar"}, "ShowHideTrackbar", Keys.T)
        ret.Add("Edit Menu...", "OpenMenuEditor", Keys.M)
        ret.Add("Help...", "OpenHelp", Keys.F1)
        ret.Add("Exit", "CloseDialog", Keys.Escape)

        Return ret
    End Function

    Private Shared Function GetExternalPreviewCmdl() As String
        Dim l = Package.GetSearchResult("mplayerc.exe", "", "MPC")

        If l.Count > 0 Then
            Return """" + l(0) + """ """ + "%working_dir%%target_name%.avs"" /start %pos_ms%"
        End If

        l = Package.GetSearchResult("KMPlayer.exe", "", "KMPlayer")

        If l.Count > 0 Then
            Return """" + l(0) + """ """ + "%working_dir%%target_name%.avs"" /start %pos_ms%"
        End If

        Return """%working_dir%%target_name%.avs"""
    End Function

    Private Sub pVideo_Paint(ByVal sender As Object, ByVal e As PaintEventArgs) Handles pVideo.Paint
        AVI.Draw(e.Graphics)
    End Sub

    Private Sub GenericMenu_Command(ByVal e As CustomMenuItemEventArgs) Handles GenericMenu.Command
        e.Handled = True

        If e.Item.MethodName = "CloseDialog" Then
            ProcessMenu(e.Item)
        Else
            For Each i As PreviewForm In Instances
                i.ProcessMenu(e.Item)
            Next
        End If
    End Sub

    Public Sub ProcessMenu(ByVal item As CustomMenuItem)
        AVI.Draw()
        GenericMenu.Process(item)
    End Sub

    Private Sub PreviewForm_Load() Handles Me.Load
        AVI.Draw()
    End Sub

    Private Sub bExtras_Paint(ByVal sender As Object, ByVal e As PaintEventArgs) Handles bExtras.Paint
        ButtonHelp.DrawDropDownGlyph(bExtras, e.Graphics, HorizontalAlignment.Center, 12)
    End Sub

    Private Sub PreviewForm_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles Me.FormClosing
        Instances.Remove(Me)
        s.LastPosition = AVI.Position
        s.WindowStatePreview = WindowState
        s.WindowPositions.Save(Me)
        AVI.Close()
        SetTrim()
    End Sub

    Private Sub SetTrim()
        Dim cut = p.TargetAVSDoc.GetFilter("Cutting")

        If p.Ranges.Count = 0 Then
            If Not cut Is Nothing Then
                p.TargetAVSDoc.Filters.Remove(cut)
            End If
        Else
            If p.UseAviSynthToCut.Value Then
                Dim aud As AviSynthFilter = p.TargetAVSDoc.GetFilter("Audio")

                If aud Is Nothing Then
                    Dim script As String = Nothing

                    If p.Audio0.File.Path.Ext = ".ac3" Then
                        script = "AudioDub(last, NicAC3Source(""%audio_file1%""))"
                    ElseIf p.Audio0.File.Path.Ext = ".mpa" OrElse p.Audio0.File.Path.Ext = ".mp2" Then
                        script = "AudioDub(last, NicMPG123Source(""%audio_file1%""))"
                    ElseIf p.Audio1.File.Path.Ext = ".ac3" Then
                        script = "AudioDub(last, NicAC3Source(""%audio_file2%""))"
                    ElseIf p.Audio1.File.Path.Ext = ".mpa" OrElse p.Audio1.File.Path.Ext = ".mp2" Then
                        script = "AudioDub(last, NicMPG123Source(""%audio_file2%""))"
                    End If

                    If Not script Is Nothing Then
                        aud = New AviSynthFilter
                        aud.Name = "Audio Source"
                        aud.Category = "Audio"
                        aud.Script = script
                        aud.Active = True
                        p.TargetAVSDoc.Filters.Add(aud)
                    End If
                End If
            End If

            If cut Is Nothing Then
                cut = New AviSynthFilter
                cut.Name = "Cutting"
                cut.Category = "Cutting"
                cut.Script = GetTrim()
                cut.Active = True
                p.TargetAVSDoc.Filters.Add(cut)
            End If
        End If

        g.MainForm.AviSynthListView.Load()
        g.MainForm.SetTargetLength(p.TargetAVSDoc.GetSeconds)
    End Sub

    Public Function GetTrim() As String
        Dim ret As String = ""

        For Each i As Range In p.Ranges
            If ret <> "" Then
                ret += " + "
            End If

            ret += "Trim(" + i.Start.ToString + "," + i.End.ToString + ")"
        Next

        Return ret
    End Function

    Private Sub Control_Enter() Handles bBackward100.Enter, bBackward10.Enter, bBackward1.Enter, bForward1.Enter, bForward10.Enter, bForward100.Enter, bRangeEnd.Enter, bRangeStart.Enter, bDeleteRange.Enter, bExtras.Enter
        ActiveControl = Nothing
    End Sub

    Private Function IsValidCutPosition() As Boolean
        For Each i As Range In p.Ranges
            If AVI.Position >= i.Start AndAlso AVI.Position <= i.End Then
                Return False
            End If
        Next

        Return True
    End Function

    Protected Overrides Sub OnHelpButtonClicked(ByVal e As CancelEventArgs)
        e.Cancel = True
        MyBase.OnHelpButtonClicked(e)
        OpenHelp()
    End Sub
End Class