Imports Stax
Imports Stax.UI
Imports Stax.AppFramework

Public Class SourceFilesForm
    Inherits DialogBase

#Region " Designer "
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    Friend WithEvents lb As ExtendedListBox
    Friend WithEvents bDown As System.Windows.Forms.Button
    Friend WithEvents bUp As System.Windows.Forms.Button
    Friend WithEvents bRemove As System.Windows.Forms.Button
    Friend WithEvents bAdd As System.Windows.Forms.Button
    Friend WithEvents TipProvider As Stax.UI.TipProvider
    Friend WithEvents cbCreateJobs As System.Windows.Forms.CheckBox
    Friend WithEvents bCombine As Stax.UI.CommandButton
    Friend WithEvents bFileBatch As Stax.UI.CommandButton
    Friend WithEvents bDirectoryBatch As Stax.UI.CommandButton
    Friend WithEvents pSide As System.Windows.Forms.Panel
    Friend WithEvents pButtons As System.Windows.Forms.Panel
    Friend WithEvents DirTree As MultiFolderTree

    '<System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.lb = New Stax.UI.ExtendedListBox
        Me.bDown = New System.Windows.Forms.Button
        Me.bUp = New System.Windows.Forms.Button
        Me.bRemove = New System.Windows.Forms.Button
        Me.bAdd = New System.Windows.Forms.Button
        Me.TipProvider = New Stax.UI.TipProvider(Me.components)
        Me.cbCreateJobs = New System.Windows.Forms.CheckBox
        Me.DirTree = New Stax.UI.MultiFolderTree
        Me.bCombine = New Stax.UI.CommandButton
        Me.bFileBatch = New Stax.UI.CommandButton
        Me.bDirectoryBatch = New Stax.UI.CommandButton
        Me.pSide = New System.Windows.Forms.Panel
        Me.pButtons = New System.Windows.Forms.Panel
        CType(Me.TipProvider, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.pSide.SuspendLayout()
        Me.pButtons.SuspendLayout()
        Me.SuspendLayout()
        '
        'lb
        '
        Me.lb.AllowDrop = True
        Me.lb.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lb.Enabled = False
        Me.lb.FormattingEnabled = True
        Me.lb.IntegralHeight = False
        Me.lb.Location = New System.Drawing.Point(12, 13)
        Me.lb.Name = "lb"
        Me.lb.Size = New System.Drawing.Size(400, 250)
        Me.lb.TabIndex = 5
        Me.lb.Visible = False
        '
        'bDown
        '
        Me.bDown.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.bDown.Image = Global.StaxRip.My.Resources.Resources.Down16
        Me.bDown.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.bDown.Location = New System.Drawing.Point(5, 130)
        Me.bDown.Name = "bDown"
        Me.bDown.Size = New System.Drawing.Size(75, 24)
        Me.bDown.TabIndex = 4
        Me.bDown.Text = "&Down"
        '
        'bUp
        '
        Me.bUp.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.bUp.Image = Global.StaxRip.My.Resources.Resources.Up16
        Me.bUp.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.bUp.Location = New System.Drawing.Point(5, 100)
        Me.bUp.Name = "bUp"
        Me.bUp.Size = New System.Drawing.Size(75, 24)
        Me.bUp.TabIndex = 3
        Me.bUp.Text = "&Up"
        '
        'bRemove
        '
        Me.bRemove.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.bRemove.Image = Global.StaxRip.My.Resources.Resources.Minus16
        Me.bRemove.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.bRemove.Location = New System.Drawing.Point(5, 29)
        Me.bRemove.Name = "bRemove"
        Me.bRemove.Size = New System.Drawing.Size(75, 24)
        Me.bRemove.TabIndex = 2
        Me.bRemove.Text = "&Remove"
        Me.bRemove.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText
        '
        'bAdd
        '
        Me.bAdd.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.bAdd.Image = Global.StaxRip.My.Resources.Resources.Plus16
        Me.bAdd.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.bAdd.Location = New System.Drawing.Point(5, -1)
        Me.bAdd.Name = "bAdd"
        Me.bAdd.Size = New System.Drawing.Size(75, 24)
        Me.bAdd.TabIndex = 1
        Me.bAdd.Text = "&Add..."
        Me.TipProvider.SetTipText(Me.bAdd, "Adds source files with a multi-select enabled file browser. Alternative methods a" & _
                "re Drag & Drop and command line, in all cases files are alphabetically sorted.")
        '
        'cbCreateJobs
        '
        Me.cbCreateJobs.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.cbCreateJobs.AutoSize = True
        Me.cbCreateJobs.Checked = True
        Me.cbCreateJobs.CheckState = System.Windows.Forms.CheckState.Checked
        Me.cbCreateJobs.Location = New System.Drawing.Point(418, 248)
        Me.cbCreateJobs.Name = "cbCreateJobs"
        Me.cbCreateJobs.Size = New System.Drawing.Size(82, 17)
        Me.cbCreateJobs.TabIndex = 7
        Me.cbCreateJobs.Text = "&Create Jobs"
        Me.TipProvider.SetTipText(Me.cbCreateJobs, "Opens files in batch mode and creates jobs. Disabling this option is useful to ba" & _
                "tch perform preparation (demuxing etc.).")
        Me.cbCreateJobs.UseVisualStyleBackColor = True
        Me.cbCreateJobs.Visible = False
        '
        'DirTree
        '
        Me.DirTree.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.DirTree.AutoCollaps = True
        Me.DirTree.CheckBoxes = True
        Me.DirTree.Enabled = False
        Me.DirTree.ExpandMode = Stax.UI.TreeNodeExpandMode.Normal
        Me.DirTree.Location = New System.Drawing.Point(12, 13)
        Me.DirTree.Name = "DirTree"
        Me.DirTree.Size = New System.Drawing.Size(400, 250)
        Me.DirTree.TabIndex = 0
        Me.DirTree.Visible = False
        '
        'bCombine
        '
        Me.bCombine.AllowDrop = True
        Me.bCombine.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.bCombine.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.bCombine.Description = "Single source file or multible files that should be merged together."
        Me.bCombine.Location = New System.Drawing.Point(30, 14)
        Me.bCombine.Name = "bCombine"
        Me.bCombine.Padding = New System.Windows.Forms.Padding(10, 2, 2, 2)
        Me.bCombine.Size = New System.Drawing.Size(446, 70)
        Me.bCombine.TabIndex = 8
        Me.bCombine.TabStop = False
        Me.bCombine.Title = "Single Or Merge"
        Me.bCombine.UseVisualStyleBackColor = False
        '
        'bFileBatch
        '
        Me.bFileBatch.AllowDrop = True
        Me.bFileBatch.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.bFileBatch.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.bFileBatch.Description = "Fully automated batch processing where every file is a separate encoding."
        Me.bFileBatch.Location = New System.Drawing.Point(30, 90)
        Me.bFileBatch.Name = "bFileBatch"
        Me.bFileBatch.Padding = New System.Windows.Forms.Padding(10, 2, 2, 2)
        Me.bFileBatch.Size = New System.Drawing.Size(446, 70)
        Me.bFileBatch.TabIndex = 9
        Me.bFileBatch.TabStop = False
        Me.bFileBatch.Title = "File Batch"
        Me.bFileBatch.UseVisualStyleBackColor = False
        '
        'bDirectoryBatch
        '
        Me.bDirectoryBatch.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.bDirectoryBatch.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.bDirectoryBatch.Description = "Directories are processed as separate encoding, containing files are merged."
        Me.bDirectoryBatch.Location = New System.Drawing.Point(30, 166)
        Me.bDirectoryBatch.Name = "bDirectoryBatch"
        Me.bDirectoryBatch.Padding = New System.Windows.Forms.Padding(10, 2, 2, 2)
        Me.bDirectoryBatch.Size = New System.Drawing.Size(446, 70)
        Me.bDirectoryBatch.TabIndex = 10
        Me.bDirectoryBatch.TabStop = False
        Me.bDirectoryBatch.Title = "Directory Batch"
        Me.bDirectoryBatch.UseVisualStyleBackColor = False
        '
        'pSide
        '
        Me.pSide.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.pSide.Controls.Add(Me.bDown)
        Me.pSide.Controls.Add(Me.bUp)
        Me.pSide.Controls.Add(Me.bAdd)
        Me.pSide.Controls.Add(Me.bRemove)
        Me.pSide.Location = New System.Drawing.Point(414, 13)
        Me.pSide.Name = "pSide"
        Me.pSide.Size = New System.Drawing.Size(91, 160)
        Me.pSide.TabIndex = 11
        Me.pSide.Visible = False
        '
        'pButtons
        '
        Me.pButtons.Controls.Add(Me.bCombine)
        Me.pButtons.Controls.Add(Me.bFileBatch)
        Me.pButtons.Controls.Add(Me.bDirectoryBatch)
        Me.pButtons.Location = New System.Drawing.Point(0, 13)
        Me.pButtons.Name = "pButtons"
        Me.pButtons.Size = New System.Drawing.Size(505, 250)
        Me.pButtons.TabIndex = 12
        '
        'SourceFilesForm
        '
        Me.ClientSize = New System.Drawing.Size(505, 318)
        Me.Controls.Add(Me.pButtons)
        Me.Controls.Add(Me.pSide)
        Me.Controls.Add(Me.DirTree)
        Me.Controls.Add(Me.cbCreateJobs)
        Me.Controls.Add(Me.lb)
        Me.Name = "SourceFilesForm"
        Me.Text = "Source Files"
        Me.Controls.SetChildIndex(Me.lb, 0)
        Me.Controls.SetChildIndex(Me.cbCreateJobs, 0)
        Me.Controls.SetChildIndex(Me.DirTree, 0)
        Me.Controls.SetChildIndex(Me.pSide, 0)
        Me.Controls.SetChildIndex(Me.pButtons, 0)
        CType(Me.TipProvider, System.ComponentModel.ISupportInitialize).EndInit()
        Me.pSide.ResumeLayout(False)
        Me.pButtons.ResumeLayout(False)
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Public Mode As SourceInputMode

    Public Sub New()
        MyBase.New()
        InitializeComponent()

        DialogButtons.bOK.Enabled = False
    End Sub

    Private Sub lbFiles_SelectedIndexChanged() Handles lb.SelectedIndexChanged
        UpdateControls()
    End Sub

    Private Sub UpdateControls()
        pButtons.Visible = False
        pButtons.Enabled = False

        If Mode = SourceInputMode.DirectoryBatch Then
            DirTree.Enabled = True
            DirTree.Visible = True
            DirTree.BringToFront()
        ElseIf Mode <> SourceInputMode.DirectoryBatch Then
            If Mode = SourceInputMode.Combine Then
                Text = bCombine.Title
            ElseIf Mode = SourceInputMode.FileBatch Then
                Text = bFileBatch.Title
            End If

            lb.Enabled = True
            lb.Visible = True
            lb.BringToFront()

            pSide.Visible = True
            pSide.BringToFront()
        End If

        ActiveControl = DialogButtons.bOK
        bAdd.Enabled = Mode <> SourceInputMode.DirectoryBatch
        bRemove.Enabled = lb.SelectedIndex > -1 AndAlso Mode <> SourceInputMode.DirectoryBatch
        bUp.Enabled = lb.CanMoveUp() AndAlso Mode <> SourceInputMode.DirectoryBatch
        bDown.Enabled = lb.CanMoveDown() AndAlso Mode <> SourceInputMode.DirectoryBatch
        DialogButtons.bOK.Enabled = lb.Items.Count > 0 OrElse DirTree.Paths.Count > 0
        cbCreateJobs.Visible = Mode <> SourceInputMode.Combine

        SetWidth(lb, lb.Items, 5)
    End Sub

    Private Sub bAdd_Click() Handles bAdd.Click
        Using d As New OpenFileDialog
            d.Multiselect = True
            d.Filter = g.GetFileDialogFilter("Video Files", s.VideoFileTypes)

            If Directory.Exists(s.LastSourceDir) Then
                d.InitialDirectory = s.LastSourceDir
            End If

            If d.ShowDialog() = DialogResult.OK Then
                lb.Items.AddRange(d.FileNames.Sort.ToArray)
                UpdateControls()
            End If
        End Using
    End Sub

    Private Sub bRemove_Click() Handles bRemove.Click
        lb.RemoveSelection()
        UpdateControls()
    End Sub

    Private Sub bUp_Click() Handles bUp.Click
        lb.MoveSelectionUp()
        UpdateControls()
    End Sub

    Private Sub bDown_Click() Handles bDown.Click
        lb.MoveSelectionDown()
        UpdateControls()
    End Sub

    Private Sub SourceFilesForm_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles Me.FormClosing
        If DialogResult = Windows.Forms.DialogResult.OK AndAlso _
            Mode = SourceInputMode.FileBatch Then

            For Each i In Files
                For Each i2 In Files
                    Dim a = i.Path.DirAndBase.ToUpper
                    Dim b = i2.Path.DirAndBase.ToUpper

                    If a <> b Then
                        If a.StartsWith(b) Then
                            Msg.Show("Files starting with the names of other files can't be used.", MsgIcon.Warning)
                            e.Cancel = True
                            Exit For
                        End If
                    End If
                Next
            Next
        End If
    End Sub

    Private Sub SourceFilesForm_HelpRequested(ByVal sender As Object, ByVal hlpevent As System.Windows.Forms.HelpEventArgs) Handles Me.HelpRequested
        Dim f As New HelpForm()
        f.Doc.WriteStart(Text)
        f.Doc.WriteP("The Source Files dialog allows to open source files in different modes.")
        f.Doc.WriteTips(TipProvider.GetTips)
        f.Show()
    End Sub

    Public ReadOnly Property Files() As List(Of String)
        Get
            Dim ret As New List(Of String)

            For Each i As String In lb.Items
                ret.Add(i)
            Next

            Return ret
        End Get
    End Property

    Private Sub DirTree_AfterCheck(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles DirTree.AfterCheck
        UpdateControls()
    End Sub

    Private Sub DirTree_BeforeCheck(ByVal sender As Object, ByVal e As TreeViewCancelEventArgs) Handles DirTree.BeforeCheck
        Dim n As FolderTreeNode = DirectCast(e.Node, FolderTreeNode)
        Dim found As Boolean

        Try 'dir access could be denied
            For Each i In Directory.GetFiles(n.Path)
                If s.VideoFileTypes.ToList.Contains(i.Path.ExtNoDot) Then
                    found = True
                End If
            Next
        Catch
        End Try

        If Not found Then
            e.Cancel = True
            Msg.Show("'" + n.Path + "' does not contain any known source files.")
        End If
    End Sub

    Private Sub SourceFilesForm_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs) Handles Me.KeyDown
        If e.KeyData = (Keys.Alt Or Keys.M) Then
            cbCreateJobs.Focus()
        End If
    End Sub

    Private Sub bCombine_Click() Handles bCombine.Click
        Text = bCombine.Title
        Mode = SourceInputMode.Combine
        bAdd_Click()
        UpdateControls()
    End Sub

    Private Sub bFileBatch_Click() Handles bFileBatch.Click
        If p.DefaultTargetName = "%source_dir_name%" Then
            p.DefaultTargetName = "%source_name%"
        End If

        Text = bFileBatch.Title
        Mode = SourceInputMode.FileBatch
        bAdd_Click()
        UpdateControls()
    End Sub

    Private Sub bDirectoryBatch_Click() Handles bDirectoryBatch.Click
        Text = bDirectoryBatch.Title
        Mode = SourceInputMode.DirectoryBatch
        UpdateControls()
    End Sub

    Private Sub bCombine_DragDrop(ByVal sender As Object, ByVal e As DragEventArgs) Handles bCombine.DragDrop
        Drop(e, SourceInputMode.Combine)
    End Sub

    Private Sub bFileBatch_DragDrop(ByVal sender As Object, ByVal e As DragEventArgs) Handles bFileBatch.DragDrop
        Drop(e, SourceInputMode.FileBatch)
    End Sub

    Private Sub lb_DragDrop(ByVal sender As Object, ByVal e As DragEventArgs) Handles lb.DragDrop
        Drop(e, Nothing)
    End Sub

    Private Sub Drop(ByVal e As DragEventArgs, ByVal mode As SourceInputMode?)
        Dim a = TryCast(e.Data.GetData(DataFormats.FileDrop), String())

        If Not a Is Nothing AndAlso a.Length > 0 Then
            If mode.HasValue Then
                Me.Mode = mode.Value
            End If

            Array.Sort(a)
            lb.Items.AddRange(a)
            UpdateControls()
        End If
    End Sub

    Private Sub bCombine_DragEnter(ByVal sender As Object, ByVal e As DragEventArgs) Handles bCombine.DragEnter, bFileBatch.DragEnter, lb.DragEnter
        e.Effect = DragDropEffects.Copy
    End Sub

    Private Sub SourceFilesForm_Shown() Handles Me.Shown
        Refresh()
        DirTree.Init()
    End Sub
End Class