Imports Microsoft.Win32
Imports System.Text.RegularExpressions
Imports System.Threading

Imports Stax
Imports Stax.UI

Public Class Packs
    Public Shared AutoCrop As New AutoCropPackage
    Public Shared AviSynth As New AviSynthPackage
    Public Shared BeSweet As New BeSweetPackage
    Public Shared Decomb As New DecombPackage
    Public Shared Deen As New DeenPackage
    Public Shared DGAVCDecode As New DGAVCDecodePackage
    Public Shared DGAVCIndex As New DGAVCIndexPackage
    Public Shared DGDecode As New DGDecodePackage
    Public Shared DGIndex As New DGIndexPackage
    Public Shared DivX As New DivXPackage
    Public Shared DivXMux As New DivXMuxPackage
    Public Shared FluxSmooth As New FluxSmoothPackage
    Public Shared Java As New JavaPackage
    Public Shared MediaInfo As New MediaInfoPackage
    Public Shared Mkvmerge As New MKVtoolnixPackage
    Public Shared MP4Box As New MP4BoxPackage
    Public Shared NeroAACEnc As New NeroAACEncPackage
    Public Shared NicAudio As New NicAudioPackage
    Public Shared PMPMuxer As New PMPMuxerPackage
    Public Shared ProjectX As New ProjectXPackage
    Public Shared TomsMoComp As New TomsMoCompPackage
    Public Shared UnDot As New UnDotPackage
    Public Shared VirtualDub As New VirtualDubPackage
    Public Shared VirtualDubMod As New VirtualDubModPackage
    Public Shared Vorbis As New VorbisPackage
    Public Shared VSFilter As New VSFilterPackage
    Public Shared VSRip As New VSRipPackage
    Public Shared x264 As New x264Package
    Public Shared XviD As New XviDPackage
    Public Shared SevenZip As New SevenZipPackage
    Public Shared Yadif As New YadifPackage
    Public Shared HaaliSplitter As New HaaliSplitterPackage

    Public Shared Packages As New Dictionary(Of String, Package)

    Shared Sub New()
        AddPackage(AviSynth) 'first

        AddPackage(AutoCrop)
        AddPackage(BeSweet)
        AddPackage(Decomb)
        AddPackage(Deen)
        AddPackage(DGAVCDecode)
        AddPackage(DGAVCIndex)
        AddPackage(DGDecode)
        AddPackage(DGIndex)
        AddPackage(DivX)
        AddPackage(DivXMux)
        AddPackage(FluxSmooth)
        AddPackage(Java)
        AddPackage(MediaInfo)
        AddPackage(Mkvmerge)
        AddPackage(MP4Box)
        AddPackage(NeroAACEnc)
        AddPackage(NicAudio)
        AddPackage(PMPMuxer)
        AddPackage(ProjectX)
        AddPackage(TomsMoComp)
        AddPackage(UnDot)
        AddPackage(VirtualDub)
        AddPackage(VirtualDubMod)
        AddPackage(Vorbis)
        AddPackage(VSFilter)
        AddPackage(VSRip)
        AddPackage(x264)
        AddPackage(XviD)
        AddPackage(SevenZip)
        AddPackage(Yadif)
        AddPackage(HaaliSplitter)
    End Sub

    Public Shared Sub AddPackage(ByVal package As Package)
        Packages.Add(package.Name, package)
    End Sub
End Class

Public MustInherit Class Package
    Public Const RemoteDomain As String = "http://www.planetdvb.net/"
    Public Const UpdateFile As String = RemoteDomain + "non_drupal/staxrip/update.xml"
    Private LateRequired As Type

    Public Shared Event InstallComplete(ByVal pack As Package)

    Private NameValue As String

    Public Property Name() As String
        Get
            Return NameValue
        End Get
        Set(ByVal Value As String)
            NameValue = Value
        End Set
    End Property

    Private VersionValue As String

    Public Property Version() As String
        Get
            Return VersionValue
        End Get
        Set(ByVal Value As String)
            VersionValue = Value
        End Set
    End Property

    Private HomepageValue As String

    Public Property Website() As String
        Get
            Return HomepageValue
        End Get
        Set(ByVal Value As String)
            HomepageValue = Value
        End Set
    End Property

    Private DescriptionValue As String

    Public Property Description() As String
        Get
            Return DescriptionValue
        End Get
        Set(ByVal Value As String)
            DescriptionValue = Value
        End Set
    End Property

    Private VersionDateValue As DateTime

    Public Property VersionDate() As DateTime
        Get
            Return VersionDateValue
        End Get
        Set(ByVal Value As DateTime)
            VersionDateValue = Value
        End Set
    End Property

    Private TreeFolderValue As String

    Public Property TreeFolder() As String
        Get
            Return TreeFolderValue
        End Get
        Set(ByVal Value As String)
            TreeFolderValue = Value
        End Set
    End Property

    Private DownLoadURLValue As String

    Public Property DownLoadURL() As String
        Get
            If DownLoadURLValue Is Nothing Then
                DownLoadURLValue = RemoteDomain + "non_drupal/staxrip/ext_apps/" + DownloadFilename
            End If

            Return DownLoadURLValue
        End Get
        Set(ByVal Value As String)
            DownLoadURLValue = Value
        End Set
    End Property

    Private DownloadFilenameValue As String

    Public Property DownloadFilename() As String
        Get
            Return DownloadFilenameValue
        End Get
        Set(ByVal Value As String)
            DownloadFilenameValue = Value
        End Set
    End Property

    Protected Overridable Sub OnInstallComplete()
        If IsCorrectVersion() Then
            ShowWrongVersionWarning = True
        End If

        If DownloadFilename.IndexOf("_") > 2 Then
            Dim name = DownloadFilename.Substring(0, DownloadFilename.IndexOf("_") + 1)

            For Each i In Directory.GetFiles(Paths.DownloadDir)
                If i.Path.Base.StartsWith(name) AndAlso Not i.Path.Name = DownloadFilename Then
                    If Msg.Show("Would you like to delete the old version:" + CrLf2 + i, MsgIcon.Question, MessageBoxButtons.OKCancel) = DialogResult.OK Then
                        FileHelp.Delete(i)
                    End If
                End If
            Next
        End If

        RaiseEvent InstallComplete(Me)
    End Sub

    Protected Function IsAviSynthPluginRequired(ByVal ParamArray filters As String()) As Boolean
        For Each iFilter In p.TargetAVSDoc.Filters
            If iFilter.Active Then
                For Each i In filters
                    If iFilter.Script.Contains(i + ".") OrElse iFilter.Script.Contains(i + "(") Then
                        Return True
                    End If
                Next
            End If
        Next

        Return False
    End Function

    Public Function VerifyOK() As Boolean
        Return VerifyOK(False)
    End Function

    Public Function VerifyOK(ByVal late As Boolean) As Boolean
        If late Then
            LateRequired = Me.GetType
        Else
            LateRequired = Nothing
        End If

        If IsRequired() Then
            If OK(GetErrorStatus()) Then
                Using f As New ExternalApplicationsForm
                    f.ShowPackage(Me)
                    f.ShowDialog()
                    g.MainForm.Refresh()
                End Using

                If OK(GetErrorStatus()) Then
                    Return False
                End If
            End If

            If OK(Version) AndAlso Not IsCorrectVersion() AndAlso _
                ShowWrongVersionWarning Then

                Dim wp As New WizardPage(Of String)
                wp.Title = If(IsOldVersion(), "Old ", "New ") + Name + " Version"
                wp.Description = "The used " + Name + " version is " + If(IsOldVersion(), "older", "newer") + " than version " + Version + " which StaxRip requires."

                wp.AddCommandButton("Get Required Version", "In most cases it's recommended to use the required version.", "get")
                wp.AddCommandButton("Continue with wrong version", "Wrong versions have often bugs or are not compatible with StaxRip.", "always")

                Select Case wp.ShowPage
                    Case "get"
                        g.MainForm.Refresh()

                        Using f As New ExternalApplicationsForm
                            f.ShowPackage(Me)
                            f.ShowDialog()
                            g.MainForm.Refresh()
                        End Using

                        If Version <> "" AndAlso Not IsCorrectVersion() Then
                            Return False
                        End If
                    Case "always"
                        ShowWrongVersionWarning = False
                End Select

                g.MainForm.Refresh()
            End If
        End If

        Return True
    End Function

    Private FilenameValue As String

    Public Overridable Property Filename() As String
        Get
            Return FilenameValue
        End Get
        Set(ByVal Value As String)
            FilenameValue = Value
        End Set
    End Property

    Public Property ShowWrongVersionWarning() As Boolean
        Get
            Dim arg As List(Of String) = s.WrongVersionWarnings
            Return Not s.WrongVersionWarnings.Contains(Name)
        End Get
        Set(ByVal Value As Boolean)
            If Value Then
                s.WrongVersionWarnings.Remove(Name)
            Else
                s.WrongVersionWarnings.Remove(Name)
                s.WrongVersionWarnings.Add(Name)
            End If
        End Set
    End Property

    Public Overridable ReadOnly Property FixedDir() As String
        Get
            Return Nothing
        End Get
    End Property

    Public Function GetDownloadPath() As String
        Return Paths.DownloadDir + DownloadFilename
    End Function

    Public Function GetFullStatus(ByRef isCritical As Boolean) As String
        Dim status = GetErrorStatus()

        If Not OK(status) Then
            If IsRequired() Then
                If OK(Version) AndAlso Not IsCorrectVersion() Then
                    isCritical = True
                    Return "Unknown version, please click on 'Download' to install the required version."
                Else
                    Return "OK"
                End If
            Else
                If OK(Version) AndAlso Not IsCorrectVersion() Then
                    Return "Unknown version though the current project might not require this application. Please click on 'Download' if you want to install the application anyway."
                Else
                    Return "OK though the current project might not require this application."
                End If
            End If
        Else
            If IsRequired() Then
                isCritical = True
            End If

            Return status
        End If
    End Function

    Public Overridable Function GetError() As String
        Return Nothing
    End Function

    Public Overridable Function GetErrorStatus() As String
        Dim required = IsRequired()

        If Not required Then
            Return "The current project might not require this application so it can be ignored altogether."
        End If

        Dim path = GetCheckedPath()

        If path Is Nothing Then
            path = FindPath()
            SetPath(path)
        End If

        If path Is Nothing Then
            Return "File not found. " + Strings.ClickDownload
        End If

        Dim fixedDir = Me.FixedDir

        If OK(fixedDir) AndAlso fixedDir.ToUpper <> Filepath.GetDir(path).ToUpper Then
            Return "The file must be located at: """ + fixedDir + """. " + Strings.ClickDownload
        End If

        Dim errorMsg = GetError()

        If Not errorMsg Is Nothing Then
            Return errorMsg
        End If

        Return Nothing
    End Function

    Private Sub InstallAsync()
        Dim pw As New Proc
        pw.File = GetDownloadPath()
        pw.Wait = True
        pw.Start()

        g.MainForm.Invoke(New Action(AddressOf OnInstallComplete))
    End Sub

    Public Overridable Function Install() As Boolean
        Try
            If DownLoadURL.ToUpper.EndsWith(".EXE") Then
                If Name = "7-Zip" Then
                    Using p As New Process
                        DirectoryHelp.Delete(Paths.ExtractDir + Name)

                        p.StartInfo.FileName = GetDownloadPath()
                        p.StartInfo.Arguments = "-s -d""" + Paths.ExtractDir + Name + """"
                        p.Start()
                        p.WaitForExit()

                        Dim path = Paths.ExtractDir + Name + "\" + Filename

                        If File.Exists(path) AndAlso p.ExitCode = 0 Then
                            SetPath(path)
                        Else
                            Throw New Exception("Failed to unpack 7-Zip. " + Stax.Strings.IOErrorMessage)
                        End If
                    End Using
                Else
                    Dim t As New Thread(AddressOf InstallAsync)
                    t.Start()
                End If
            ElseIf DownLoadURL.EndsWith(".zip") OrElse DownLoadURL.EndsWith(".7z") Then
                Dim d = FixedDir

                If OK(d) Then
                    Extract(d)
                Else
                    Extract(Paths.ExtractDir + Name)
                End If

                OnInstallComplete()
            End If

            Return True
        Catch ex As Exception
            Msg.Show(ex.Message)
            Return False
        End Try
    End Function

    Protected Sub Extract(ByVal targetDir As String)
        Using p As New Process
            p.StartInfo.FileName = Packs.SevenZip.Path
            p.StartInfo.Arguments = "x """ + GetDownloadPath() + """ -o""" + targetDir + """ -aoa"
            p.StartInfo.WindowStyle = ProcessWindowStyle.Hidden
            p.Start()
            p.WaitForExit()

            Dim path = DirPath.AppendSeparator(targetDir) + Filename

            If File.Exists(path) AndAlso p.ExitCode = 0 Then
                SetPath(path)
            Else
                Using p2 As New Process
                    p2.StartInfo.FileName = Packs.SevenZip.Path.Replace("7z.exe", "7z.admin.exe")
                    p2.StartInfo.Arguments = "x """ + GetDownloadPath() + """ -o""" + targetDir + """ -aoa"
                    p2.StartInfo.WindowStyle = ProcessWindowStyle.Hidden
                    p2.Start()
                    p2.WaitForExit()

                    Dim path2 = DirPath.AppendSeparator(targetDir) + Filename

                    If File.Exists(path2) AndAlso p2.ExitCode = 0 Then
                        SetPath(path2)
                    Else
                        Throw New Exception("Failed to unpack archive. " + Stax.Strings.IOErrorMessage)
                    End If
                End Using
            End If
        End Using
    End Sub

    Public Overridable Function IsRequired() As Boolean
        Return Me.GetType Is LateRequired
    End Function

    Public Function IsCorrectVersion() As Boolean
        Return IsCorrectVersion(Path)
    End Function

    Public Overridable Function IsOldVersion() As Boolean
        Return OK(Path) AndAlso File.GetLastWriteTimeUtc(Path).AddDays(2) < VersionDate
    End Function

    Public Overridable Function IsCorrectVersion(ByVal path As String) As Boolean
        If OK(path) Then
            Dim dt = File.GetLastWriteTimeUtc(path)
            Return dt.AddDays(-2) < VersionDate AndAlso dt.AddDays(2) > VersionDate
        End If
    End Function

    Public Sub SetPath(ByVal path As String)
        s.PackagePaths(Name) = path
    End Sub

    Protected Overridable Function FindPath() As String
        Dim ret As String = Nothing

        For Each i In GetSearchResult()
            ret = i

            If IsCorrectVersion(i) Then
                Return i
            End If
        Next

        Return ret
    End Function

    Public ReadOnly Property Path() As String
        Get
            If s.PackagePaths.ContainsKey(Name) Then
                Return s.PackagePaths(Name)
            End If

            Return Nothing
        End Get
    End Property

    Public Function GetCheckedPath() As String
        If s.PackagePaths.ContainsKey(Name) AndAlso File.Exists(s.PackagePaths(Name)) Then
            Return s.PackagePaths(Name)
        End If

        Return Nothing
    End Function

    Public Overrides Function ToString() As String
        Return Name
    End Function

    Private Shared Sub AddIfFound(ByVal path As String, ByVal list As List(Of String))
        For Each i As String In list
            If path.EqualIgnoreCase(i) Then
                Exit Sub
            End If
        Next

        If File.Exists(path) Then
            list.Add(path)
        End If
    End Sub

    Public Overridable Function GetSearchResult() As List(Of String)
        Return GetSearchResult(Filename, FixedDir, Name)
    End Function

    Public Shared Function GetSearchResult(ByVal filename As String, ByVal fixedDir As String, ByVal name As String) As List(Of String)
        Dim list As New List(Of String)
        Dim value As String

        Try
            'system 32 bit wrapper on 64 bit sys
            AddIfFound(CommonDirs.Windows + "syswow64\" + filename, list)

            'system
            AddIfFound(CommonDirs.System + filename, list)

            'startup
            AddIfFound(CommonDirs.Startup + filename, list)

            'FixedDir
            If Not String.IsNullOrEmpty(fixedDir) Then
                AddIfFound(fixedDir + filename, list)
            End If

            'applications
            For Each i As String In DirectoryHelp.FindFiles(Paths.ExtractDir + name, filename, True)
                AddIfFound(i, list)
            Next

            'programs
            For Each i As String In DirectoryHelp.FindFiles(CommonDirs.Programs + name, filename, True)
                AddIfFound(i, list)
            Next

            'AutoGK
            Dim key As RegistryKey = Registry.LocalMachine.OpenSubKey("SOFTWARE\AutoGK")

            If Not key Is Nothing Then
                Using key
                    Dim dir As String = CStr(key.GetValue("InstallDir"))

                    If Not dir Is Nothing Then
                        For Each i As String In DirectoryHelp.FindFiles(dir, filename, True)
                            AddIfFound(i, list)
                        Next
                    End If
                End Using
            End If

            'MUICache
            key = Registry.CurrentUser.OpenSubKey("Software\Microsoft\Windows\ShellNoRoam\MUICache")

            If Not key Is Nothing Then
                Using key
                    For Each i As String In key.GetValueNames
                        If i.ToUpper.Contains(filename.ToUpper) Then
                            Dim m As Match = Regex.Match(i, "\w:\\.+\\" + filename, RegexOptions.IgnoreCase)

                            If m.Success Then
                                AddIfFound(m.Value, list)
                            End If
                        End If
                    Next
                End Using
            End If

            'Gordian Knot
            key = Registry.CurrentUser.OpenSubKey("Software\GordianKnot")

            If Not key Is Nothing Then
                Using key
                    For Each i As String In key.GetValueNames
                        value = CStr(key.GetValue(i))

                        If Filepath.GetName(value).ToUpper() = _
                            filename.ToUpper() Then

                            AddIfFound(value, list)
                        End If
                    Next
                End Using
            End If

            'megui
            key = Registry.CurrentUser.OpenSubKey("Software\Microsoft\Windows\ShellNoRoam\MUICache")

            If Not key Is Nothing Then
                Using key
                    For Each i As String In key.GetValueNames
                        If i.ToUpper.Contains("MEGUI.EXE") Then
                            Dim m As Match = Regex.Match(i, "\w:\\.+\\megui\.exe", RegexOptions.IgnoreCase)

                            If m.Success AndAlso File.Exists(m.Value) Then
                                For Each iFile As String In DirectoryHelp.FindFiles(Filepath.GetDir(m.Value), filename, True)
                                    AddIfFound(iFile, list)
                                Next
                            End If
                        End If
                    Next
                End Using
            End If

            'shell applications
            value = RegistryHelp.ClassesRoot.GetString("Applications\" + filename + "\shell\open\command", Nothing)

            If Not value Is Nothing Then
                value = Regex.Match(value, "\w:\\.+\.exe", RegexOptions.IgnoreCase).Value
                AddIfFound(value, list)
            End If

            'uninstall
            key = Registry.LocalMachine.OpenSubKey("SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\" + name)

            If Not key Is Nothing Then
                value = CStr(key.GetValue("UninstallString"))

                If Not value Is Nothing Then
                    Dim m As Match = Regex.Match(value, "\w:\\.+\.exe", RegexOptions.IgnoreCase)

                    If m.Success Then
                        Dim path As String = Filepath.GetDir(m.Value) + filename
                        AddIfFound(path, list)
                    End If
                End If

                key.Close()
            End If
        Catch ex As Exception
        End Try

        Return list
    End Function
End Class

Public Class AutoCropPackage
    Inherits AviSynthPluginPackage

    Public Sub New()
        Name = "AutoCrop"
        Filename = "AutoCrop.dll"
        Website = "http://avisynth.org/warpenterprises"
        Description = "AutoCrop is a AviSynth plugin used for automatic cropping."
        Version = "1.1"
        VersionDate = New DateTime(2003, 6, 17)
        DownloadFilename = "AutoCrop_1.1.7z"
        TreeFolder = "AviSynth Plugins"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        Return True
    End Function
End Class

Public Class DeenPackage
    Inherits AviSynthPluginPackage

    Public Sub New()
        Name = "Deen"
        Filename = "Deen.dll"
        Website = "http://ziquash.chez.tiscali.fr"
        Description = "Deen is a AviSynth plugin used for denoising."
        Version = "2005-07-05"
        VersionDate = New DateTime(2005, 7, 5)
        DownloadFilename = "Deen_2005-07-05.zip"
        TreeFolder = "AviSynth Plugins"
        FilterNames = New String() {"Deen"}
    End Sub
End Class

Public Class TomsMoCompPackage
    Inherits AviSynthPluginPackage

    Public Sub New()
        Name = "TomsMoComp"
        Filename = "TomsMoComp.dll"
        Website = "http://www6.impacthosting.com/trbarry"
        Description = "Motion compensation deinterlace filter."
        Version = "0.0.1.8"
        VersionDate = New DateTime(2008, 3, 1)
        DownloadFilename = "TomsMoComp_0.0.1.8.zip"
        TreeFolder = "AviSynth Plugins"
        FilterNames = New String() {"TomsMoComp"}
    End Sub
End Class

Public Class UnDotPackage
    Inherits AviSynthPluginPackage

    Public Sub New()
        Name = "UnDot"
        Filename = "UnDot.dll"
        Website = "http://www6.impacthosting.com/trbarry"
        Description = "UnDot is a simple median filter for removing dots, that is stray orphan pixels and mosquito noise."
        Version = "2003-01-18"
        VersionDate = New DateTime(2003, 1, 18)
        DownloadFilename = "Undot_2003-01-18.zip"
        TreeFolder = "AviSynth Plugins"
        FilterNames = New String() {"UnDot"}
    End Sub
End Class

Public Class NicAudioPackage
    Inherits AviSynthPluginPackage

    Public Sub New()
        Name = "NicAudio"
        Filename = "NicAudio.dll"
        Website = "http://www.codeplex.com/NicAudio"
        Description = "AviSynth audio source filter."
        Version = "2.0.1"
        VersionDate = New DateTime(2008, 4, 9)
        DownloadFilename = "NicAudio_2.0.1.zip"
        TreeFolder = "AviSynth Plugins"
        FilterNames = New String() {"NicAC3Source", "NicDTSSource", "NicMPG123Source", "NicLPCMSource"}
    End Sub
End Class

Public Class AviSynthPackage
    Inherits Package

    Public Sub New()
        Name = "AviSynth"
        Filename = "avisynth.dll"
        Version = "2.5.7"
        Website = "http://www.avisynth.org"
        Description = "AviSynth is used to perform audio and video transformations."
        VersionDate = New DateTime(2006, 12, 31)
        DownloadFilename = "Avisynth_2.5.7.exe"
        TreeFolder = "Misc"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        Return True
    End Function
End Class

Public MustInherit Class AviSynthPluginPackage
    Inherits Package

    Protected FilterNames As String()

    Public Overrides Function GetErrorStatus() As String
        Dim pluginDir = FixedDir

        If Not Directory.Exists(pluginDir) Then
            Return "There is no plugin directory, please click download in order to install AviSynth."
        End If

        Dim path = GetCheckedPath()

        If path Is Nothing Then
            Return MyBase.GetErrorStatus
        End If

        If pluginDir.ToUpper <> Filepath.GetDir(path).ToUpper Then
            Return "The plugin must be located in the plugin directory at:" + CrLf2 + pluginDir + CrLf2 + Strings.ClickDownload
        End If

        Return MyBase.GetErrorStatus()
    End Function

    Public Overrides ReadOnly Property FixedDir() As String
        Get
            Return Paths.AviSynthPluginsDir
        End Get
    End Property

    Public Overrides Function IsRequired() As Boolean
        If MyBase.IsRequired Then
            Return True
        End If

        If OK(FilterNames) Then
            For Each i In FilterNames
                If IsAviSynthPluginRequired(i) Then
                    Return True
                End If
            Next
        End If

        Return False
    End Function
End Class

Public Class BeSweetPackage
    Inherits Package

    Public Sub New()
        Name = "BeSweet"
        Filename = "BeSweet.exe"
        Version = "1.5b31"
        Website = "http://dspguru.doom9.net"
        DownloadFilename = "BeSweet_1.5b31.zip"
        Description = "BeSweet transcodes audio."
        VersionDate = New DateTime(2005, 9, 8)
        TreeFolder = "Misc"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        If MyBase.IsRequired Then
            Return True
        End If

        If TypeOf p.Audio0 Is CmdlAudioProfile Then
            Dim profile = DirectCast(p.Audio0, CmdlAudioProfile)

            If profile.CommandLines.Contains("-core(") Then
                Return True
            End If
        End If

        If TypeOf p.Audio1 Is CmdlAudioProfile Then
            Dim profile = DirectCast(p.Audio1, CmdlAudioProfile)

            If profile.CommandLines.Contains("-core(") Then
                Return True
            End If
        End If

        If p.Ranges.Count > 0 Then
            Return True
        End If

        Return False
    End Function

    Public Overrides Function GetErrorStatus() As String
        If GetCheckedPath() Is Nothing Then
            Return MyBase.GetErrorStatus
        End If

        For Each iProfile As AudioProfile In New AudioProfile() {p.Audio0, p.Audio1}
            If TypeOf iProfile Is CmdlAudioProfile Then
                Dim profile As CmdlAudioProfile = DirectCast(iProfile, CmdlAudioProfile)

                If profile.CommandLines.Contains("-lame(") Then
                    If Not CheckLib(Filepath.GetDir(Path) + "lame_enc.dll", New DateTime(2005, 12, 22)) Then
                        Return "There is a problem with the lame library. " + Strings.ClickDownload
                    End If
                End If

                If profile.CommandLines.Contains("-bsn(") Then
                    If Not CheckLib(Filepath.GetDir(Path) + "bsn.dll", New DateTime(2006, 5, 22)) Then
                        Return "There is a problem with the bsn library. " + Strings.ClickDownload
                    End If
                End If
            End If
        Next

        Return MyBase.GetErrorStatus
    End Function

    Private Function CheckLib(ByVal filename As String, ByVal dt As DateTime) As Boolean
        Return File.Exists(filename) AndAlso File.GetLastWriteTime(filename) > dt.AddDays(-2)
    End Function
End Class

Public Class VorbisPackage
    Inherits Package

    Public Sub New()
        Name = "Vorbis"
        Version = "TuVb5.5"
        Filename = "libvorbis.dll"
        Description = "Vorbis is a audio codec."
        Website = "http://www.vorbis.com"
        VersionDate = New DateTime(2008, 3, 31)
        DownloadFilename = "Vorbis_TuVb5.5.zip"
        TreeFolder = "Codecs & Encoders"
    End Sub

    Public Overrides ReadOnly Property FixedDir() As String
        Get
            Dim dir As String = Filepath.GetDir(Packs.BeSweet.Path)

            If Not Directory.Exists(dir) Then
                dir = Paths.ExtractDir + Packs.BeSweet.Name + "\"
            End If

            Return dir
        End Get
    End Property

    Public Overrides Function IsRequired() As Boolean
        If MyBase.IsRequired Then
            Return True
        End If

        If TypeOf p.Audio0 Is CmdlAudioProfile Then
            Dim profile = DirectCast(p.Audio0, CmdlAudioProfile)

            If profile.CommandLines.Contains("-ogg(") Then
                Return True
            End If
        End If

        Return False
    End Function
End Class

Public Class VSRipPackage
    Inherits Package

    Public Sub New()
        Name = "VSRip"
        Version = "1.0.0.6"
        Filename = "VSRip.exe"
        Description = "VSRip rips VobSub subtitles."
        Website = "http://sourceforge.net/projects/guliverkli"
        VersionDate = New DateTime(2003, 5, 30)
        DownloadFilename = "VSRip_1.0.0.6.zip"
        TreeFolder = "Demuxers"
    End Sub
End Class

Public Class NeroAACEncPackage
    Inherits Package

    Public Sub New()
        Name = "Nero AAC Encoder"
        Version = "1.3.3.0"
        Filename = "neroAacEnc.exe"
        Description = "Free AAC encoder"
        Website = "http://www.nero.com/eng/downloads-nerodigital-nero-aac-codec.php"
        VersionDate = New DateTime(2008, 9, 17)
        DownloadFilename = "NeroAACEncoder_1.3.3.0.7z"
        TreeFolder = "Codecs & Encoders"
    End Sub

    Public Overrides ReadOnly Property FixedDir() As String
        Get
            Dim dir = Filepath.GetDir(Packs.BeSweet.Path)

            If Not Directory.Exists(dir) Then
                dir = Paths.ExtractDir + Packs.BeSweet.Name + "\"
            End If

            Return dir
        End Get
    End Property

    Public Overrides Function IsRequired() As Boolean
        If MyBase.IsRequired Then
            Return True
        End If

        For Each i In New AudioProfile() {p.Audio0, p.Audio1}.OfType(Of CmdlAudioProfile)()
            If i.CommandLines.Contains("-bsn(") Then
                Return True
            End If
        Next

        Return False
    End Function
End Class

Public Class DecombPackage
    Inherits AviSynthPluginPackage

    Public Sub New()
        Name = "Decomb"
        Version = "5.2.2"
        Filename = "Decomb.dll"
        Description = "Decomb is a AviSynth plugin that performs various field operations like deinterlacing."
        Website = "http://neuron2.net"
        VersionDate = New DateTime(2005, 9, 4)
        DownloadFilename = "Decomb_5.2.2.zip"
        TreeFolder = "AviSynth Plugins"
        FilterNames = New String() {"FieldDeinterlace", "Telecide", "Decimate"}
    End Sub
End Class

Public Class DGDecodePackage
    Inherits AviSynthPluginPackage

    Public Sub New()
        Name = "DGDecode"
        Filename = "DGDecode.dll"
        Website = "http://www.neuron2.net"
        Description = "DGDecode decodes MPEG-2 sources."
        Version = "1.5.0"
        VersionDate = New DateTime(2008, 5, 13)
        DownloadFilename = "DGDecode_1.5.0.7z"
        TreeFolder = "AviSynth Plugins"
        FilterNames = New String() {"MPEG2Source", "LumaYV12", "BlindPP", "Deblock"}
    End Sub
End Class

Public Class DGIndexPackage
    Inherits Package

    Public Sub New()
        Name = "DGIndex"
        Filename = "DGIndex.exe"
        Version = "1.5.0"
        Website = "http://www.neuron2.net"
        Description = "DGIndex demuxes and indexes MPEG-2 sources."
        DownloadFilename = "DGMPGDec_1.5.0.7z"
        VersionDate = New DateTime(2008, 5, 16)
        TreeFolder = "Demuxers"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        Return MyBase.IsRequired OrElse Packs.DGDecode.IsRequired
    End Function
End Class

Public Class DGAVCIndexPackage
    Inherits Package

    Public Sub New()
        Name = "DGAVCIndex"
        Filename = "DGAVCIndex.exe"
        Version = "1.0.2"
        Website = "http://www.neuron2.net"
        Description = "DGAVCIndex demuxes and indexes AVC sources."
        DownloadFilename = "DGAVCIndex_1.0.2.7z"
        VersionDate = New DateTime(2008, 9, 29)
        TreeFolder = "Demuxers"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        Return MyBase.IsRequired OrElse Packs.DGAVCDecode.IsRequired
    End Function
End Class

Public Class DGAVCDecodePackage
    Inherits AviSynthPluginPackage

    Public Sub New()
        Name = "DGAVCDecode"
        Filename = "DGAVCDecode.dll"
        Website = "http://www.neuron2.net"
        Description = "DGAVCDecode decodes AVC sources."
        Version = "1.0.2"
        VersionDate = New DateTime(2008, 9, 29)
        DownloadFilename = "DGAVCDecode_1.0.2.7z"
        TreeFolder = "AviSynth Plugins"
        FilterNames = New String() {"AVCSource"}
    End Sub
End Class

Public Class DivXPackage
    Inherits Package

    Public Sub New()
        Name = "DivX"
        Filename = "DivX.dll"
        Version = "6.8 or higher"
        Website = "http://www.divx.com"
        Description = "DivX is a MPEG4 codec."
        VersionDate = New DateTime(2008, 2, 21)
        TreeFolder = "Codecs & Encoders"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        Return MyBase.IsRequired OrElse TypeOf p.VideoEncoder Is DivXVirtualDubEncoder
    End Function

    Public Overrides Function GetErrorStatus() As String
        If GetCheckedPath() Is Nothing Then
            Return MyBase.GetErrorStatus
        End If

        If File.GetLastWriteTime(Path) < (New DateTime(2005, 9, 28)).AddDays(-2) Then
            Return "StaxRip requires at least DivX version 6.0.3. Please click on 'Download' to install the required version."
        End If

        Return MyBase.GetErrorStatus
    End Function

    Public Overrides Function IsCorrectVersion(ByVal path As String) As Boolean
        If OK(path) Then
            Dim dt = File.GetLastWriteTimeUtc(path)

            If dt.AddDays(2) < VersionDate Then
                Return False
            End If

            Return True
        End If
    End Function
End Class

Public Class FluxSmoothPackage
    Inherits AviSynthPluginPackage

    Public Sub New()
        Name = "FluxSmooth"
        Filename = "FluxSmooth.dll"
        Description = "FluxSmooth is a AviSynth plugin that removes noise from poor video sources."
        Version = "1.1a"
        VersionDate = New DateTime(2004, 7, 29)
        Website = "http://avisynth.org/warpenterprises"
        DownloadFilename = "FluxSmooth_1.1a.zip"
        TreeFolder = "AviSynth Plugins"
        FilterNames = New String() {"FluxSmoothT", "FluxSmoothST"}
    End Sub
End Class

Public Class VSFilterPackage
    Inherits AviSynthPluginPackage

    Public Sub New()
        Name = "VSFilter"
        Filename = "VSFilter.dll"
        Description = "VSFilter is a AviSynth plugin for adding hardcoded subtitles. Furthermore it's a DirectShow Filter to display optional subtitles."
        Version = "2.37"
        VersionDate = New DateTime(2005, 11, 25)
        Website = "http://sourceforge.net/projects/guliverkli"
        DownloadFilename = "VSFilter_2.37.zip"
        TreeFolder = "AviSynth Plugins"
        FilterNames = New String() {"VobSub", "TextSub"}
    End Sub

    Public Overrides Function Install() As Boolean
        Dim ret = MyBase.Install()

        If File.Exists(Path) Then
            Process.Start("regsvr32", "/s """ + Path + """")
        End If

        Return ret
    End Function
End Class

Public Class JavaPackage
    Inherits Package

    Public Sub New()
        Name = "Java"
        Filename = "Java.exe"
        Website = "http://java.com"
        Description = "Java is required by ProjectX."
        TreeFolder = "Misc"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        If MyBase.IsRequired Then
            Return True
        End If

        Return Not Packs.ProjectX.Path Is Nothing
    End Function
End Class

Public Class VirtualDubPackage
    Inherits Package

    Public Sub New()
        Name = "VirtualDub"
        Filename = "VirtualDub.exe"
        Version = "1.8.1"
        Website = "http://www.virtualdub.org"
        Description = "VirtualDub is a AVI processing application used to create AVI files."
        VersionDate = New DateTime(2008, 6, 15)
        DownloadFilename = "VirtualDub_1.8.1.7z"
        TreeFolder = "Misc"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        Return MyBase.IsRequired OrElse TypeOf p.VideoEncoder Is VirtualDubEncoder AndAlso _
            DirectCast(p.VideoEncoder, VirtualDubEncoder).UseVirtualDub
    End Function
End Class

Public Class ProjectXPackage
    Inherits Package

    Public Sub New()
        Name = "ProjectX"
        Filename = "ProjectX.jar"
        Version = "0.90.2"
        Website = "http://www.lucike.info"
        Description = "ProjectX is a MPEG-2 demuxer, it can be disabled in the project options under preparation."
        VersionDate = New DateTime(2005, 11, 26)
        DownloadFilename = "ProjectX_0.90.2.zip"
        TreeFolder = "Demuxers"
    End Sub
End Class

Public Class XviDPackage
    Inherits Package

    Public Sub New()
        Name = "XviD"
        Filename = "xvidvfw.dll"
        Version = "1.1.3"
        Website = "http://www.xvid.org"
        Description = "XviD is a MPEG-4 codec."
        VersionDate = New DateTime(2007, 6, 28)
        DownloadFilename = "XviD_1.1.3.exe"
        TreeFolder = "Codecs & Encoders"
    End Sub

    Public Overrides Function GetErrorStatus() As String
        If Paths.GetYV12DecoderPath Is Nothing Then
            Return "StaxRip requires either ffdshow or XviD as YV12 decoder. It's recommended to install ffdshow but you can also click download to install XviD."
        End If

        Return MyBase.GetErrorStatus
    End Function

    Public Overrides Function IsRequired() As Boolean
        Return MyBase.IsRequired OrElse Paths.GetYV12DecoderPath Is Nothing
    End Function
End Class

Public Class x264Package
    Inherits Package

    Public Sub New()
        Name = "x264"
        Filename = "x264.exe"
        Version = "1136"
        Website = "http://x264.nl"
        Description = "x264 is a video codec producing files much smaller than XviD/DivX."
        VersionDate = New DateTime(2009, 4, 6)
        DownloadFilename = "x264_1136.7z"
        TreeFolder = "Codecs & Encoders"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        Return MyBase.IsRequired OrElse TypeOf p.VideoEncoder Is x264Encoder
    End Function
End Class

Public Class VirtualDubModPackage
    Inherits Package

    Public Sub New()
        Name = "VirtualDubMod"
        Filename = "VirtualDubMod.exe"
        Version = "1.5.10.2"
        Website = "http://virtualdubmod.sourceforge.net"
        Description = "VirtualDubMod is used for tasks like encoding, muxing, demuxing and cutting."
        VersionDate = New DateTime(2005, 8, 25)
        DownloadFilename = "VirtualDubMod_1.5.10.2.zip"
        TreeFolder = "Misc"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        If MyBase.IsRequired Then
            Return True
        End If

        If TypeOf p.VideoEncoder Is VirtualDubEncoder AndAlso _
            Not DirectCast(p.VideoEncoder, VirtualDubEncoder).UseVirtualDub Then

            Return True
        End If

        If p.Ranges.Count > 0 Then
            Return True
        End If

        Return False
    End Function
End Class

Public Class MP4BoxPackage
    Inherits Package

    Public Sub New()
        Name = "MP4Box"
        Filename = "MP4Box.exe"
        Version = "0.4.5"
        Website = "http://ffdshow.faireal.net/mirror/gpac/dev"
        Description = "MP4Box is a MP4 Muxer."
        VersionDate = New DateTime(2008, 3, 18)
        DownloadFilename = "MP4Box_0.4.5.zip"
        TreeFolder = "Muxers"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        Return MyBase.IsRequired OrElse TypeOf p.VideoEncoder.Muxer Is MP4Muxer
    End Function
End Class

Public Class MKVtoolnixPackage
    Inherits Package

    Public Sub New()
        Name = "MKVtoolnix"
        Filename = "mkvmerge.exe"
        Version = "2.3.0"
        Website = "http://www.bunkus.org/videotools/mkvtoolnix"
        Description = "MKVtoolnix contains mkvmerge which is a MKV muxer."
        DownloadFilename = "mkvtoolnix_2.3.0.exe"
        VersionDate = New DateTime(2008, 9, 8)
        TreeFolder = "Muxers"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        Return MyBase.IsRequired OrElse TypeOf p.VideoEncoder.Muxer Is MkvMuxer
    End Function
End Class

Public Class MediaInfoPackage
    Inherits Package

    Public Sub New()
        Name = "MediaInfo"
        Filename = "MediaInfo.dll"
        Version = "0.7.7.2"
        Website = "http://mediainfo.sourceforge.net"
        Description = "MediaInfo is used by StaxRip to read infos from media files."
        VersionDate = New DateTime(2008, 6, 11)
        DownloadFilename = "MediaInfo_0.7.7.2.7z"
        TreeFolder = "Misc"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        Return True
    End Function
End Class

Public Class DivXMuxPackage
    Inherits Package

    Public Sub New()
        Name = "DivXMux"
        Filename = "DivXMux.exe"
        Version = "6.1 build 36"
        Website = "http://labs.divx.com/archives/000066.html"
        Description = "DivXMux is is DIVX muxer."
        VersionDate = New DateTime(2006, 3, 6)
        DownloadFilename = "DivXMux_6.1_build_36.zip"
        TreeFolder = "Muxers"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        Return MyBase.IsRequired OrElse TypeOf p.VideoEncoder.Muxer Is DivXMuxer
    End Function
End Class

Public Class PMPMuxerPackage
    Inherits Package

    Public Sub New()
        Name = "PMP Muxer"
        Filename = "pmp_muxer.exe"
        Version = "2.0"
        Website = "http://jonny.leffe.dnsalias.com"
        Description = "PMP Muxer is a PMP muxer for the PlayStation Portable."
        VersionDate = New DateTime(2006, 3, 27)
        DownloadFilename = "PMP_Muxer_2.0.zip"
        TreeFolder = "Muxers"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        Return MyBase.IsRequired OrElse TypeOf p.VideoEncoder.Muxer Is PMPMuxer
    End Function
End Class

Public Class SevenZipPackage
    Inherits Package

    Public Sub New()
        Name = "7-Zip"
        Filename = "7z.exe"
        Version = "4.57"
        Website = "http://www.7-zip.org"
        Description = "Used to unpack the external applications without own installer."
        VersionDate = New DateTime(2007, 12, 20)
        DownloadFilename = "7-Zip_4.57_2.exe"
        TreeFolder = "Misc"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        Return True
    End Function

    Public Sub Pack(ByVal srcDir As String, ByVal targetFile As String)
        Using p As New Process
            p.StartInfo.WindowStyle = ProcessWindowStyle.Hidden
            p.StartInfo.FileName = Path
            p.StartInfo.Arguments = " a -t7z """ + targetFile + """ -r """ + srcDir + "*" + """"
            p.Start()
            p.WaitForExit()

            If p.ExitCode <> 0 Then
                Msg.Show("Failed to pack directory with exit code " & p.ExitCode, MsgIcon.Error)
            End If
        End Using
    End Sub
End Class

Public Class YadifPackage
    Inherits Package

    Public Sub New()
        Name = "Yadif"
        Filename = "yadif.dll"
        Website = "http://avisynth.org.ru"
        Description = "Port of YADIF (Yet Another DeInterlacing Filter) from MPlayer."
        Version = "0.9"
        VersionDate = New DateTime(2007, 7, 22)
        DownloadFilename = "yadif.7z"
        TreeFolder = "AviSynth Plugins"
    End Sub

    Public Overrides Function IsRequired() As Boolean
        If MyBase.IsRequired Then
            Return True
        End If

        Return IsAviSynthPluginRequired("Yadif")
    End Function
End Class

Public Class ComPackage
    Inherits Package

    Public GUID As String

    Public Overrides Function GetError() As String
        If Not File.Exists(FindPath) Then
            Return Name + " isn't registered. " + Strings.ClickDownload
        End If

        Return Nothing
    End Function

    Protected Overrides Function FindPath() As String
        Return RegistryHelp.ClassesRoot.GetString("CLSID\" + GUID + "\InprocServer32", Nothing)
    End Function
End Class

Public Class HaaliSplitterPackage
    Inherits ComPackage

    Public Sub New()
        Name = "Haali Media Splitter"
        Filename = "splitter.ax"
        Website = "http://haali.cs.msu.ru/mkv"
        Description = "DirectShow filter for MKV, MP4 and other formats."
        Version = "29/03/2008"
        GUID = "{55DA30FC-F16B-49FC-BAA5-AE59FC65F82D}"
        VersionDate = New DateTime(2008, 3, 29)
        DownloadFilename = "MatroskaSplitter_08-03-29.exe"
        TreeFolder = "Direct Show Filter"
    End Sub
End Class